﻿#pragma TextEncoding = "UTF-8"
#pragma rtGlobals=3				// Use modern global access method and strict wave access
#pragma Module	= QGraphstyle

#pragma DefaultTab={3,20,4}		// Set default tab width in Igor Pro 9 and later

//###############################################################################################
Function/S QGFetchGMacroList()
	String list = MacroList("G*",";","SUBTYPE:GraphStyle,WIN:QGS_style.ipf")
	String copy = GetUserData("QGraphSizePanel", "", "CopyStyle")
//	print copy    // for bug
	if (strlen(copy))
		list += "CStyle"
	endif
	copy = GetUserData("QGraphSizePanel", "", "CopyStyleName")
//	print copy		   // for bug
	if (strlen(copy))
		list += " ("+copy+")"
	endif
	list += ";From Clipboard;"
//	print list
	return list
End
//#########--**--        ------------------------------------------------          --**--#########
//									Standard Graph Macros style
//#########--**--        ------------------------------------------------          --**--#########
Proc GStyle_Box() : GraphStyle
	PauseUpdate; Silent 1
	GetAxis/Q right
	if (V_flag == 1)
		ModifyGraph/Z mirror(left)=2
	endif
	GetAxis/Q top
	if (V_flag == 1)
		ModifyGraph/Z mirror(bottom)=2
	endif
	ModifyGraph noLabel=0
	ModifyGraph standoff=0
	ModifyGraph ZisZ=1
	ModifyGraph tick=0
	ModifyGraph notation(left)=1
	ModifyGraph axisOnTop=1
	ModifyGraph minor=1
	if ((GetKeyState(0) & 2^0) != 0)	// ctrl / command = paper style (no left axis notation)
		ModifyGraph tick(left)=3
		ModifyGraph noLabel(left)=1
	endif
	ResumeUpdate
EndMacro
//
Proc GStyle_Norm() : GraphStyle
	PauseUpdate; Silent 1		// modifying window...
	ModifyGraph/Z expand=1.65,gFont="Times New Roman",gfSize=14//,width=243,height=139
	ModifyGraph/Z marker[0]=8,marker[1]=19
	ModifyGraph/Z rgb[0]=(1,16019,65535)
	ModifyGraph/Z msize=1.1
	ModifyGraph/Z tick=2
	ModifyGraph/Z mirror=1
	ModifyGraph/Z font="Times New Roman"
	ModifyGraph/Z fSize=14
	ModifyGraph/Z standoff(left)=0
	ModifyGraph/Z axThick=0.8
	ModifyGraph/Z btLen=1.6
	ModifyGraph/Z btThick=0.8
	ModifyGraph/Z minor=0
	SetWindow kwTopWin,hook(ScrollToMagnify)=ScrollWheelToMagnify#ScrollToMagnifyHook
EndMacro
//
Proc GStyle_NormImage() : GraphStyle
	PauseUpdate; Silent 1		// modifying window...
//	ModifyGraph/Z margin(left)=38,margin(top)=28,margin(right)=30,expand=1.25//,width=184, height=240
	ModifyGraph/Z expand=1.65	//,width=184, height=240
	ModifyGraph/Z tick=2
	ModifyGraph/Z mirror=1
	ModifyGraph/Z font="Times New Roman"
	ModifyGraph/Z fSize=12
	ModifyGraph/Z axThick=0.6
	ModifyGraph/Z btLen=1.6
	ModifyGraph/Z btThick=0.6
	SetWindow kwTopWin,hook(hScrollToZoom)=ScrollToZoom#hookScrollToZoom
	SetWindow kwTopWin,hook(ScrollToMagnify)=ScrollWheelToMagnify#ScrollToMagnifyHook
EndMacro
//
Proc GStyle_NormPlot() : GraphStyle
	PauseUpdate; Silent 1		// modifying window...
	ModifyGraph/Z expand=-1.65,gFont="Times New Roman",gfSize=14
	
	ModifyGraph/Z lSize=0.7
	ModifyGraph/Z msize=1.1
	ModifyGraph/Z tick=2
	ModifyGraph/Z mirror=1
	ModifyGraph/Z font="Times New Roman"
	ModifyGraph/Z fSize=14
	ModifyGraph/Z standoff=0
	ModifyGraph/Z axThick=0.8
	ModifyGraph/Z notation(left)=1
	ModifyGraph/Z ZisZ=1
	ModifyGraph/Z axisOnTop=1
	ModifyGraph/Z btLen=1.6
	ModifyGraph/Z btThick=0.8
	SetWindow kwTopWin,hook(ScrollToMagnify)=ScrollWheelToMagnify#ScrollToMagnifyHook
EndMacro
//
Proc GLabel_X_phase_Y_KE() : GraphStyle
	Label/Z left "\u#2Energy (eV) \\E"
	Label/Z bottom "\u#2Relative Phase (π)"
EndMacro
//
Proc GLabel_X_KE_Y_Phase() : GraphStyle
	Label/Z bottom "\u#2Energy (eV) \\E"
	Label/Z left "\u#2Relative Phase (π)"
EndMacro
//___
Proc GLabel_X_KE_Y_intensity() : GraphStyle
	Label/Z left "\u#2Intensity [a.u.] \\E"
	Label/Z bottom "\u#2Energy (eV)"
EndMacro
//
Proc GLabel_X_intensity_Y_KE() : GraphStyle
	Label/Z bottom "\u#2Intensity [a.u.] \\E"
	Label/Z left "\u#2Energy (eV)"
EndMacro
//
Proc GLabel_MOM() : GraphStyle
	Label/Z left "\u#2P\\By\\M [a.u]"
	Label/Z bottom "\u#2P\\Bx\M [a.u]"
EndMacro
//___
Proc GMark_Add() : GraphStyle
	String pName = winName(0,64)
	GetWindow $(pName) title
	
	string gName = S_Value[4,inf]
	if (!strlen(gName))
		return 0
	endif
	
	ControlInfo/W=$"QGraphSizePanel" WaterMark
	String Mark = S_value
//	print Mark
	
//	Dowindow/F gName
	SetDrawLayer/W=$gName/K ProgBack
	SetDrawLayer/W=$gName ProgBack
	
	SetDrawEnv xcoord= rel,ycoord= rel
	SetDrawEnv fsize= 65
	SetDrawEnv textrgb= (62451,62451,62451),textrot= 49,fsize= 66;DelayUpdate
	SetDrawEnv textxjust= 1,textyjust= 1;
	DrawText 0.5,0.15,Mark
	
	SetDrawEnv xcoord= rel,ycoord= rel
	SetDrawEnv fsize= 65
	SetDrawEnv textrgb= (62451,62451,62451),textrot= 49,fsize= 66;DelayUpdate
	SetDrawEnv textxjust= 1,textyjust= 1;
	DrawText 0.5,0.65,Mark
	
EndMacro
//
//___
Proc GMark_Clear() : GraphStyle
	String pName = winName(0,64)
	GetWindow $(pName) title
	
	string gName = S_Value[4,inf]
	if (!strlen(gName))
		return 0
	endif
	
	ControlInfo/W=$"QGraphSizePanel" WaterMark
	String Mark = S_value
//	print Mark
	
//	Dowindow/F gName
	SetDrawLayer/W=$gName/K ProgBack
	
EndMacro