﻿#pragma TextEncoding= "UTF-8"
#pragma rtGlobals 	= 3
#pragma IgorVersion	= 6.36
#pragma IndependentModule	= QGraphTools
#pragma DefaultTab	= {3,20,4}		// set default tab width in Igor Pro 9 and later
#include "QGS_style"
//
//	This version of the procedure is a personal modification based on chozo's project.
//	see the attached GSrelease.txt for the release info or click the version button
//	
Static Constant		GTversion 			= 3.1		// release version of this procedure
static Constant 	GLStepsize 			= 2			// 2/4 = 0.5 for subwin pose step				
static Constant		TTgglemax_row 		= 33		// max trace per column in trace Toggler
//
static StrConstant 	ksGraphSizeUnitSave	= "V_SizePanelUnit"			
// 	global variable name which saves the current unit setting of the Graph Size Panel
Static Constant 	GSPNarrowHeight 	= 83
//	width for right side
static StrConstant 	ksTraceIgnoreList	= "w_base;MQP_*;*_tan;"						
//
Menu "Q Ways", hideable
	"---"
	"Graph Size and Margins Panel/3", /Q, BuildGraphSizePanel()
End
Menu "GraphPopup", dynamic
	"---"
	"Graph Size and Margins Panel", /Q, BuildGraphSizePanel()
End
//#########--**--        ------------------------------------------------        --**--#########
//										GRAPH SIZE PANEL
//#########--**--        ------------------------------------------------        --**--#########
Function BuildGraphSizePanel()   // using:: QGraphTools#BuildGraphSizePanel()
	String pName = "QGraphSizePanel"
	String topGraphHost = KBActiveGraphHost()
//
	if (WinType(pName))
		DoWindow/F/Z $pName
		return 0
	endif
	if (ItemsinList(WinList("*", ";", "WIN:1")) == 0)
		Abort "No graphs available. Create a graph first."
	endif
	DefaultGuiFont/Mac popup={"_IgorSmall",12,0}
	DefaultGuiFont/Win popup={"_IgorSmall",12,0}

	NewPanel/K=1/W=(500,60,806,388)/N=$pName as "GS"
	ModifyPanel /W=$pName ,fixedSize=1, cbRGB=(63222,62708,59624)
	ModifyPanel /W=$pName ,noEdit=1

#if IgorVersion() > 9		//  requires igor9, 
	if( PanelResolution(pName) == 72 )
		ModifyPanel /W=$pName ,expand = 1.28 
	else
		ModifyPanel /W=$pName ,expand = 1  
	endif
#endif
	SetWindow $pName hook(UpdateHook)=SizePanelUpdateFunc
	AutoPositionWindow/M=0/R=$topGraphHost $pName		// right side of the top graph
//
	buidframe()			// draw the frame line
	buidgroup()			// four group for the function module
	addWinPosi()		// add winPosition in the graphsizepanel
//
//###################    plot parameter
	TitleBox TplotW			,pos={138-12, 40}	,title="Plot W:"	,size={48,16}	,anchor=MC	,labelBack=(16380,28400,65535)
	TitleBox TplotH			,pos={187-12, 73}	,title="Plot H:"	,size={48,16}	,anchor=MC	,labelBack=(16380,28400,65535)
	TitleBox TgraphW		,pos={87-10,  73}	,title="Graph H:"	,size={52,16}	,anchor=MC	,labelBack=(8000,39320,19940)
	TitleBox TgraphH		,pos={138-12,109}	,title="Graph W:"	,size={52,16}	,anchor=MC	,labelBack=(8000,39320,19940)
	
	ModifyControlList ControlNameList(pName,";","T*"),fixedSize=1,frame=0,font="Consolas",fStyle=1,fColor=(65535,65535,65535)
//
//###################	value
	SetVariable VLeftMargin		,pos={3,   91}		,value = _NUM:38
	SetVariable VBottomMargin	,pos={134-12,167}	,value = _NUM:36
	SetVariable VRightMargin	,pos={246-12, 91}	,value = _NUM:25
	SetVariable VTopMargin		,pos={134-12, 14}	,value = _NUM:15
	
	SetVariable VPlotWidth		,pos={134-12, 59}	,value = _NUM:278
	SetVariable VPlotHeight		,pos={183-12, 92}	,value = _NUM:217

	SetVariable VGraphHeight	,pos={83-4,  92}	,value = _NUM:268
	SetVariable VGraphWidth		,pos={134-12,128}	,value = _NUM:341
	SetVariable VMagnification	,pos={56, 124}
	
	ModifyControlList ControlNameList(pName,";","V*"),limits={1,1200,0},size={45, 20},fStyle=1,bodyWidth=35,proc=Gsize_VarControl	
	SetVariable VMagnification	,limits={0.3,6,0.05} 	,title="magn.:", bodyWidth=50,format="%g x", value=_NUM:1.5
	SetVariable VGraphFont		,pos={44, 143}	,title="gfont:", limits={0,100,1}, bodyWidth=40, value=_NUM:10,proc=Gsize_VarControl
	SetVariable VGraphFont		,help={"Sets the global graph font. If shift+enter is pressed instead the global axes font is changed. Insert 0 to reset to 'auto'"}
	
	SetVariable WaterMark  pos={9,167},size={97,24},fColor=(65535,0,26214),value=_STR:"Q_mark",help={"set water mark in watermark style macro"}
//	
//###################   
	Button ModifyNGpButton	,pos={213,  167}	,size={18,16}	,title="M"	,proc=Gsize_CopyPaste 	,fColor=(65535,32768,58981)	,help={"Modify Graph..."}
	Button CatchNGpButton	,pos={237,  167}	,size={48,16}	,title="To Front"	,proc=Gsize_CopyPaste 	,fColor=(65535,32768,58981)	,help={"Bring top graph to front"}
	SetVariable RoundSigh	,value = _NUM:0		,disable = 1
	Button ResetAllButton	,pos={240-17, 29}	,size={45,17}	,title="to auto",proc=Gsize_CopyPaste,fColor=(65535,32768,58981)	,help={"Resets all size controls to automatic mode."}
//	CheckBox cPrint			,pos={217,  167}	,size={23,23}	,title="print cmd"	,value=0,help={"Prints modify commands into history."}
	TitleBox SwapTitle		,pos={147-10, 77}	,size={60,23}	,title="\JCswap:"	,frame=0
	CheckBox SwapAxes		,pos={160-10, 93}	,size={23,23}	,title=""			,value=0	,proc=Gsize_SwapGraph

	PopupMenu SizeUnit		,pos={219-10, 7}	,size={50,15}	,title="unit: "	,mode=1	,proc=Gsize_PresetPopup	,popvalue="points",value= #"\"points;inches;cm\""
	CheckBox KeepAutoMode	,pos={270, 30}	,size={23,23}	,title=""	,value=0,labelBack=(65535,65535,65535)
	CheckBox KeepAutoMode	,help={"Automatically resets the mode to Auto after changing the size."}, disable = 0
	CheckBox standoffAxes	,pos={237-31, 48}	,title="axis standoff:",proc=standoffControl,size={102,15},side=1//,labelBack=(65535,60076,49151)

//
//###################	GrAxisToggle
	TitleBox btLenTitle1	,pos={35,203},size={26,15},title="Ticks:",fSize=11,frame=0
	TitleBox btLenTitle2	,pos={70,203},size={33,15},title="Labels:",fSize=11,frame=0
		
	CheckBox cAxis_left		,pos={9, 220}	,title="L"	,value=0
	CheckBox cAxis_bottom	,pos={9, 241}	,title="B"	,value=0
	CheckBox cAxis_right	,pos={9, 262}	,title="R"	,value=0
	CheckBox cAxis_top		,pos={9, 282}	,title="T"	,value=0
	
	ModifyControlList ControlNameList(pName,";","cAxis_*")	,size={23, 23}	,proc=Gsize_ToggleAxis
//-------------------	
	SetVariable tlAxis_left		,pos={25,220}	,value=_NUM:0	,valueBackColor=(65535,54611,49151)//,title="Tick:"
	SetVariable tlAxis_bottom	,pos={25,241}	,value=_NUM:0	,valueBackColor=(65535,54611,49151)
	SetVariable tlAxis_right	,pos={25,262}	,value=_NUM:0	,valueBackColor=(65535,54611,49151)
	SetVariable tlAxis_top		,pos={25,282}	,value=_NUM:0	,valueBackColor=(65535,54611,49151)

	ModifyControlList ControlNameList(pName,";","tlAxis_*")		,limits={-50, 50, 0},size={40,19} ,bodyWidth=30 ,proc=Gaxis_VarControl
	Button CopyAllButton		,pos={10, 302},size={43,20}	,title="CopyS"	,proc=Gsize_CopyPaste,fColor=(65535,32768,58981)
	Button PasteAllButton		,pos={59,302},size={43,20}	,title="PasteS"	,proc=Gsize_CopyPaste,fColor=(65535,32768,58981)
//-------------------
	SetVariable alAxis_left		,pos={63,220}	,value=_NUM:0	//	,title="Axis:"
	SetVariable alAxis_bottom	,pos={63,241}	,value=_NUM:0
	SetVariable alAxis_right	,pos={63,262}	,value=_NUM:0
	SetVariable alAxis_top		,pos={63,282}	,value=_NUM:0
	ModifyControlList ControlNameList(pName,";","alAxis_*")		,limits={-350, 350, 0},size={40,19} ,bodyWidth=35 ,proc=Gaxis_VarControl	

//
//###################	GrStyleSetting	
	Button CopyStyleButton		,pos={127-12,205},size={58, 20}	,title="CopyStyle"	,proc=Gsize_CopyPaste,help={"Copies the style of the top graph (hold shift to save style to the clipboard)."}
	CheckBox CopyAxes			,pos={187-12,208},size={28, 20}	,title="inclu.axs RG",value=1,help={"Copies the axis scaling as well."}
	PopupMenu GrStyle			,pos={146-12,228},size={117,20}	,title="Sty:" ,bodyWidth=117,mode=1	,value = QGFetchGMacroList()
	Button RevertButton			,pos={265-12,205},size={41, 20}	,title="Revert"		,proc=Gsize_CopyPaste	,help={"Reverts to last style before Apply was pressed."}
	Button ApplyButton			,pos={265-12,228},size={41, 20}	,title="\f01Apply"	,proc=Gsize_CopyPaste	,help={"Applies selected style to the top graph."}
//
//###################	group0	
	TitleBox gThickTitle		,pos={128-12, 260}	,title="axThick:"	,frame=0
	SetVariable QGraphThick		,pos={155-12, 260}	,fStyle=0		,limits={0,4.9,0.2}	,bodyWidth=36,value=_NUM:0.5	,proc=Gsize_VarControl
	Button AxisOffButton		,pos={209-12, 260}	,size={27,17}	,title="axis",userData="axisoff",proc=Gaxis_OfforOn ,fColor=(49151,53155,65535),help={"axis Off or on"}
	
	TitleBox btLenTitle			,pos={128-12, 280}	,title="btLens:"	,frame=0
	SetVariable QGraphbtLen		,pos={155-12, 280}	,fStyle=0		,limits={0.1,50,0.2},bodyWidth=36,value=_NUM:1.3	,proc=Gsize_VarControl
	Button GraphbtLenButton		,pos={213-12, 281}	,size={19,15}	,title="bt"	,userData="btout"	,proc=Gbt_InorOut ,fColor=(65535,32768,58981)
//###################	right side   GrextraSetting
	CheckBox chk3,win=$pName	,pos={302-8, 5},size={37,16},value=1,mode=2, title="", Proc = RsideCheckBoxes	//	open or close the rightside

	Button legendNGpButton		,pos={318-11,205}	,size={49,20}	,title="Legend"	,proc=GSAlityControl 	,fColor=(49151,53155,65535)	,help={"add legned for visiable items in the graph"}	
	Button AddtagGpButton		,pos={370-11,205}	,size={28,20}	,title="Tag",fColor=(49151,53155,65535),proc=GTag_OfforOn	,help={"Add a text of first trace or image"}	
	Button offtagGpButton 		,pos={370-11,205}	,size={28,20}	,title="Tag",fColor=(49151,53155,65535),proc=GTag_OfforOn 	,help={"delete a text of first trace or image"}, disable=1
	Button colorscaleNGpButton	,pos={318-11,228}	,size={58,20}	,title="ColorScale",userData="CSCoff",proc=CSC_OfforOn ,fColor=(49151,53155,65535),help={"CSC Off or on"}
	CheckBox colorscaleToHori	,pos={320-11,250}	,size={23,20}	,title="SC to Horiz"	,value=0,proc=Gsize_ToggleAxis
	Button renameNGpButton		,pos={318-11,267}	,size={49,20}	,title="Rename"	,proc=GSAlityControl 	,fColor=(49151,53155,65535)	,help={"change graph's name"}
	Button tintedBackground		,pos={371-11,267}	,size={26,20}	,title="BG" ,proc=QTintedBackgroundButtonProc,help={"Add Tinted Background to graph"} ,fColor=(65535,32768,58981)	
//###################
//-------------------	right side
	variable R_P = 310, inter = 21, B_H = 18, B_W = 72
	Button CalltracePanelButton		,pos={R_P, 4}			,title="traceModify"	,size={B_W,B_H}	,help={"call trace modify window"}
	Button CalltraceToggleButton	,pos={R_P, 4 + inter}	,title="traceToggler"	,size={B_W,B_H}	,help={"togger for trace window"}
	Button CalltraceOffsetButton	,pos={R_P, 4 + inter*2}	,title="trace Info"		,size={B_W,B_H}	,help={"Updating..."}
//	Button CallSubWcontrolButton	,pos={R_P, 4 + inter*3}	,title="WinPosition"	,size={B_W,B_H}	,help={"subwindow setting"}
	Button CallSpliteAxisButton		,pos={R_P, 4 + inter*3}	,title="Splite_Axis"	,size={B_W,B_H}	,help={"splite the axis"}
	Button CallcolorcontrolButton	,pos={R_P, 4 + inter*4}	,title="ColorTB"		,size={B_W,B_H}	,help={"image color table board"}
	Button CallIPDeskTopButton		,pos={R_P, 4 + inter*5}	,title="IP DeskTop"		,size={B_W,B_H}	,help={"Igor spaces"}
	Button CallSSSButton			,pos={R_P, 4 + inter*6}	,title="SSS"			,size={B_W,B_H}	,help={"in future"}
	Button CallBBBButton			,pos={R_P, 4 + inter*7}	,title="BBB"			,size={B_W,B_H}	,help={"in future"}
	Button CallUpdaterButton		,pos={R_P, 4 + inter*8}	,title="Updater"		,size={B_W,B_H}	,help={"projects updater"}
//
//###################	
	Button goWebsiteButton		,pos={303,293},title="Src Web"	,size={47,17},proc=GSAlityControl,fColor=(65535,32768,58981),help={"not a web project"}
	Button QWebButton			,pos={353,293},title="bilibili"	,size={37,17},proc=GSAlityControl,fColor=(65535,32768,58981),help={"access the bilibili"}

	ModifyControlList ControlNameList(pName,";","Call*")   ,proc=GSAlityControl,fColor=(49151,49152,65535) //
	Button CallUpdaterButton	,fColor=(65535,54611,49151)
	
//-------------------
	ModifyControlList ControlNameList(pName,";","*") ,fsize=11
	if (CmpStr(IgorInfo(2), "Macintosh") == 0)
		ModifyControlList ControlNameList(pName,";","*") ,fsize=10
	endif

	NVAR/Z unit = root:$ksGraphSizeUnitSave				// load saved settings
	if (NVAR_Exists(unit))
		PopupMenu SizeUnit ,mode=unit // 0 for point
	
//		String CtrlList = RemoveFromList("VMagnification;VGraphFont;",ControlNameList(pName,";","V*"))
//		Variable div  = unit == 1 ? 1 : (unit == 2 ? 72 : 72/2.54)	// in points, inches or cm, prefer the point
//		Variable step = unit == 1 ? 1 : (unit == 2 ? 0.014 : 0.036)
//		ModifyControlList CtrlList ,limits={0,8000/div,step}		// official max size is 8000 points
	endif
	FetchLatestGraphSizeValues()    // graph data
	fetchLatestSubWinValues()		// window position
	
	addVersionTag()
	return 0
End
//
function buidframe()

	SetDrawLayer UserBack
//	peripheral frame
	SetDrawEnv linethick = 0.1, dash = 14, fillfgc = (62708,61937,62194)
	DrawRRect 4,3,298-9,188
//	inner frame
	SetDrawEnv linethick = 0.3, dash = 7, fillfgc = (63736,54227,47545)
	DrawRect 60,36,248-11,160
//	right top corner shadow
	SetDrawEnv fillfgc= (65535,60076,49151),linethick = 0
	DrawRect 214-10,6,296-10,63
//	left bottom corner shadow
	SetDrawEnv fillfgc= (65535,60076,49151),linethick = 0
	DrawRect 9,120,103,161
//
//###################
	SetDrawEnv linefgc= (0,0,65535),arrow= 3,arrowlen= 15,arrowfat= 0.3
	DrawLine 63,68,230,68		// plot W
	SetDrawEnv linefgc= (0,0,65535),arrow= 3,arrowlen= 15,arrowfat= 0.3
	DrawLine 210-12,43,210-12,156  	// plot H
	SetDrawEnv linefgc= (1,39321,19939),arrow= 3,arrowlen= 15,arrowfat= 0.3
	DrawLine 10,115,292-12,115		// graph W
	SetDrawEnv linefgc= (1,39321,19939),arrow= 3,arrowlen= 15,arrowfat= 0.3
	DrawLine 110,9,110,186		// graph H
//	inner frame
	SetDrawEnv linethick= 2,linefgc= (36870,14755,58980),arrow= 3
	DrawLine 124,161,124,186	// margin bottom
	SetDrawEnv linethick= 2,linefgc= (36870,14755,58980),arrow= 3
	DrawLine 124,9,124,34		// margin top
	SetDrawEnv linethick= 2,linefgc= (36870,14755,58980),arrow= 3
	DrawLine 10,84,51,84		// margin left
	SetDrawEnv linethick= 2,linefgc= (36870,14755,58980),arrow= 3
	DrawLine 251-12,84,296-12,84		// margin right
	SetDrawEnv fstyle= 1,textrgb= (65535,16385,16385)
//	dividing line, right side
	SetDrawEnv linethick= 0.8,linefgc= (43690,43690,43690),dash= 12
	DrawLine 307-8,18,307-8,181
//	
	SetDrawEnv linethick= .2,linefgc= (0,0,0),arrow= 3,arrowfat= 0.40
	DrawLine 9,30,9,75		// posi_Y
	SetDrawEnv linethick= .2,linefgc= (0,0,0),arrow= 3,arrowfat= 0.40
	DrawLine 30,9,104,9		// posi_X
end
function buidgroup()
	GroupBox GrAxisToggle	,pos={4,  189},size={104,138},title="Ticks & Labels:"	,fStyle=3,frame=1
	GroupBox GrAxisToggle	,fColor=(44253,29492,58982),labelBack=(65535,64250,59110)
	
	GroupBox GrStyleSet		,pos={123-12,189},size={188, 64},title="Styles Sets:"	,fStyle=3,frame=1
	GroupBox GrStyleSet		,fColor=(8000,39320,19940),labelBack=(61680,61423,62708)
	
	GroupBox group0 		,pos={123-12,256},size={188, 71}						
	GroupBox group0			,labelBack=(65535,64250,59110),labelBack=(65535,64250,59110)
	
	GroupBox GrextraSet		,pos={314-11,189},size={88, 102},title="Annota.:"		,fStyle=3,frame=1
	GroupBox GrextraSet		,fColor=(65535,0,26214),labelBack=(59624,60909,60395)
end
function addWinPosi()
	Button restPoseButton		,pos={8,8},size={15,15}	,proc=GSAlityControl,title="R",fSize=14
	Button restPoseButton		,fColor=(65535,0,26214),help={"post all subWin to left top corner of Host#"}
	
	SetVariable SubWinX_posi	,pos={47, 13},size={43,18}, limits={-1000,1000,0}, proc=SubWinTBControl,value=_NUM:0
	SetVariable SubWinY_posi	,pos={13, 45},size={43,18}, limits={-1000,1000,0}, proc=SubWinTBControl,value=_NUM:0
	
	Button winFrameButton		,pos={95+22, 65+237},size={40,20}, title="Frame",userData="frameoff",proc=frame_InorOut ,fColor=(49151,53155,65535),help={"frame Off or on for subwin"}

    Button CopySubwinAloneButton	,pos={145+17,65+237},size={65,20}, proc=GSAlityControl
	Button CopySubwinAloneButton	,title="SubwinPup",fColor=(65535,43688,32768),help={"copy the subwindow into a standalone graph window"}
	
	Button KillSubwinAloneButton	,pos={220+12,65+237},size={60,20}, proc=GSAlityControl
	Button KillSubwinAloneButton	,title="KillSubW",fColor=(65535,0,26214),help={"kill subwindow, not work for Host# Window"}
end
//#########--**--        ------------------------------------------------          --**--#########
function  BuildSubWinTBPanel()
	String topGraph=WinName(0,1)
	String pName = "SubWinTB"
	String gName = getTopGraph()
	
	variable sl = strlen(gName)
//	print sl
	sl = sl < 47 ? 47:sl
//
	string ttlabel = "set position for:" //+ gName
	DoWindow/K $pName
	if (WinType(pName) == 7)
		DoWindow/F/Z $pName
		return 0
	endif
	if (ItemsinList(WinList("*", ";", "WIN:1")) == 0)
		Abort "No graphs available. Create a graph first."
	endif
	NewPanel/K=1/FLT=0/N=$pName/W=(0,0,289 + 5*(sl-47),120)
	ModifyPanel /W=$pName ,fixedSize=1 ,noEdit=1
	//RenameWindow #, SubWinTBControl
	SetWindow $pName hook(UpdateHook)=SubWinTBUpdateFunc
	
	TitleBox tb1,pos={1,12},size={0,0},anchor=LC,title=ttlabel
    TitleBox tb1 frame=4,labelBack=(65535,60076,49151)
    SetVariable Subgname win=$pName,pos={0, 22}, size={289 + 5*(sl-47),18}, frame=0, value= _STR:gName

    if(strlen(topGraph))
        AutoPositionWindow/M=1/R=$topGraph $pName
    endif
    
    SetDrawLayer UserBack
	SetDrawEnv linefgc= (1,16019,65535),arrow= 3,arrowlen= 15,arrowfat= 0.3
	DrawLine 75,50,185,50
	
	SetDrawEnv linefgc= (1,16019,65535),arrow= 3,arrowlen= 15,arrowfat= 0.3
	DrawLine 31,58,31,115
	
	SetDrawEnv fsize= 16,fstyle= 1
	DrawText 6,59,"Point："
	
	SetDrawEnv fsize= 16,fstyle= 0
	DrawText 55,59,"X:"
	SetDrawEnv fsize= 16,fstyle= 0
	DrawText 6,115,"Y:"
	SetDrawEnv fsize= 14,fstyle= 1,textrgb= (65535,16385,16385)
	DrawText 190,58,"StepS:"
	
	Button printsubwinName		title="Print",pos={95, 3},size={45,18},proc=GSAlityControl ,fColor=(49151,53155,65535),help={"print current subwin name"}

	SetVariable SubWinX_posi		,pos={103, 42},size={55,18}, limits={-1000,1000,0}, proc=SubWinTBControl,value=_NUM:0
	SetVariable SubWinY_posi		,pos={4,  77},size={55,18}, limits={-1000,1000,0}, proc=SubWinTBControl,value=_NUM:0
	
//	SetVariable SubWinStep_size		,pos={235,42},size={50,18}, limits={0.5,30,0.75},value=_NUM:0.5
//	SetVariable SubWinStep_size		,valueColor=(65535,0,0),valueBackColor=(65535,60076,49151),help={"Moving step size, \"ctrl\" speed up "}
    
    Button winFrameButton		title="Frame",pos={95, 65},size={45,21}	,userData="frameoff",proc=frame_InorOut ,fColor=(49151,53155,65535),help={"frame Off or on for subwin"}

    Button CopySubwinAloneButton	,pos={145,65},size={70,21}	,proc=GSAlityControl
	Button CopySubwinAloneButton	,title="SubwinPup",fColor=(65535,43688,32768),help={"copy the subwindow into a standalone graph window"}
	
	Button KillSubwinAloneButton	,pos={220,65},size={65,21}	,proc=GSAlityControl
	Button KillSubwinAloneButton	,title="KillSubW",fColor=(65535,0,26214),help={"kill subwindow, not work for Host# Window"}
	
	Button restPoseButton			,pos={220,90},size={65,21}	,proc=GSAlityControl
	Button restPoseButton			,title="RestPose",fColor=(65535,0,26214),help={"post all subWin to right top corner of Host#"}
	
	fetchLatestSubWinValues()
	return 0
end
//---------------------------------- panel update helper function --------------------------------
Function SubWinTBUpdateFunc(s)
	STRUCT WMWinHookStruct &s
	If (s.eventCode == 0)
		FetchLatestSubWinValues()
		return 1
	endif
	return 0
End
//
Function SubWinTBControl(s) : SetVariableControl
	struct WMSetVariableAction &s
	if (s.eventCode == 2) // enter key
		SubWinTBVarChange(s.ctrlName, s.dval, 2)
	elseif(s.eventCode == 4) // Mouse scroll wheel up
		SubWinTBVarChange(s.ctrlName, s.dval, 4)
	elseif(s.eventCode == 5) // Mouse scroll wheel down
		SubWinTBVarChange(s.ctrlName, s.dval, 5)
	endif
	return 0
End
//#########--**--        ------------------------------------------------          --**--#########
static Function SubWinTBVarChange(ctrlName, val, increaseExpansion)
	String ctrlName
	Variable val
	variable increaseExpansion
	String gName = getTopGraph()
	String pName = Winname(0,64)
	if (!strlen(gName))
		return 0
	endif
	variable modifier = 1
//	modifier = V_Value

	if ((GetKeyState(0) & 2^0) != 0)	// ctrl / command
		modifier *= 28
//		print modifier
	elseif((GetKeyState(0) & 2^2))		// shift
		modifier *= 42
//		print modifier
	endif

	ControlInfo/W=$pName SubWinX_posi
	Variable X_posi = V_Value
	ControlInfo/W=$pName SubWinY_posi
	Variable Y_posi = V_Value
//	ControlInfo/W=$pName SubWinStep_size
//	Variable Step_Size = V_Value
//	print SubgnameT
	if (increaseExpansion==4)  //   mousescroll up or down
		val += GLStepsize/4 * modifier
	elseif(increaseExpansion==5)
		val -= GLStepsize/4 * modifier
	endif
	
	FetchLatestGraphSizeValues()
	GraphSizeMode(1)  // turn the graph size mode to absoute !!!!!!!!!!!!!!!!
	if(GrepString(gName,"#"))  // for subwindow
		StrSwitch(ctrlName)
			case "SubWinX_posi":
				MoveSubwindow/w=$gName fnum = (val,Y_posi,120, 120)
//				MoveSubwindow/w=$gName fguide = (val,Y_posi,12, 12)		// ???
//				can not work??
				SetVariable SubWinX_posi, win=$pName, value = _NUM:val
			break
			case "SubWinY_posi":
				MoveSubwindow/w=$gName fnum = (X_posi,val,120, 120)
				SetVariable SubWinY_posi, win=$pName, value = _NUM:val
			break
		EndSwitch
	else
		StrSwitch(ctrlName)	// also can be worked for the host graph
			case "SubWinX_posi":
				Movewindow/w=$gName val,Y_posi,120, 120
				SetVariable SubWinX_posi, win=$pName, value = _NUM:val
			break
			case "SubWinY_posi":   // printsubwinName
				Movewindow/w=$gName X_posi,val,120, 120
				SetVariable SubWinY_posi, win=$pName, value = _NUM:val
			break
		EndSwitch
	endif
//	GraphSizeMode(0)  // turn the graph size mode to auto,  maybe no need
//	fetchLatestSubWinValues() 		// ?? can not work ??  why??
	return 0
end
//
function GraphSizeMode(Opts)
	variable opts	// 1 : aboslute,  0 : auto
	String gName = getTopGraph()
	
	ControlInfo /W=$"QGraphSizePanel" VPlotWidth
	Variable plot_w = V_Value
	ControlInfo /W=$"QGraphSizePanel" VPlotHeight
	Variable plot_h = V_Value
	
	Switch (Opts)
		case 0:	//
			ModifyGraph/W=$gName/Z width=0, height=0
		break
		case 1:	//
			ModifyGraph/W=$gName/Z width=plot_w, height=plot_h
		break
		default:
			
		break
	EndSwitch
	
	return 0
end
//#########--**--        ------------------------------------------------          --**--#########
static Function/S getTopMainGraph()
	return StringFromList(0,WinList("*", ";", "WIN:1"))
End
//------------------------------------------------------------------------------------------------
static Function/S getTopGraph()
	String windows = WinList("*", ";", "")
	String topwindow = StringFromList(0, windows)
//	print windows
	Variable i = 0
	do													// try finding a valid graph, even if it is not the top one
		Variable wtype = WinType(topwindow)
		if (wtype == 1 || wtype == 3 || wtype == 7)		// top window is graph or a type that can contain a graph
			GetWindow/Z $topwindow, activeSW			// for the active sub window (this can also be the top-level, 
														// if there are not children, or no child is active)
			if (strlen(S_value) > 0 && WinType(S_value) == 1)
				return S_value							// this isn't necessarily an immediate child of top window
			elseif (wtype == 1)
				return topwindow
			endif
		endif
		topwindow = StringFromList(i, windows)
		i += 1
	while (strlen(topWindow) > 0)
	return ""		// no graph found
End
//++++++++++++++++++++++++++++++++ panel update helper function ++++++++++++++++++++++++++++++++++
Function SizePanelUpdateFunc(s)
	STRUCT WMWinHookStruct &s
	If (s.eventCode == 0)
		FetchLatestGraphSizeValues()
		FetchLatestSubWinValues()
		return 1
	endif
	return 0
End
//------------------------------------------------------------------------------------------------
Function Gsize_SwapGraph(s) : CheckBoxControl
	STRUCT WMCheckboxAction& s
	
	String gName = getTopGraph()
	if (s.eventCode == 2 && strlen(gName) > 0)
		ModifyGraph/W=$gName/Z swapXY=s.checked
		ControlInfo/W=$(s.win) cPrint
		if (V_Value && V_flag == 2)
			print "•ModifyGraph swapXY="+num2str(s.checked)
		endif
		FetchLatestGraphSizeValues()
	endif
	return 0
End
//------------------------------------------------------------------------------------------------
Function Gsize_ToggleAxis(s) : CheckBoxControl
	STRUCT WMCheckboxAction& s
	String gName = getTopGraph()
	if (s.eventCode == 2 && strlen(gName) > 0)
		SetAxisLabelsAndTicks(ReplaceString("cAxis_",s.ctrlName,""), gName, !s.checked)
		FetchLatestGraphSizeValues()
	endif
	return 0
End
//#########--**--        ------------------------------------------------          --**--#########
Function QTintedBackgroundButtonProc(ba) : ButtonControl
	STRUCT WMButtonAction & ba
	if (ba.eventCode != 2)
		return 0
	endif
	
	Execute/P/Q/Z "INSERTINCLUDE  <TintedWindowBackground>, version>=8"
	Execute/P/Q/Z "COMPILEPROCEDURES "
	Execute/P/Q/Z "WM_TintedBkgPanel()"
	Execute/P/Q/Z "PopupMenu restoreLayerPop,win=TintPanel,popvalue=\"ProgFront\",mode=5"
End
//
function RsideCheckBoxes(s)
	STRUCT WMCheckboxAction& s
	String pName = winName(0, 64)
	
	variable mag = 1
#if IgorVersion() > 7	
	GetWindow/Z kwTopWin wsize
	if(PanelResolution(pName) < 96)
		mag = 1 //  requires igor9, 
	else
		mag = 1*1.60/1.2 //  requires igor9, 
	endif
#endif	
	if (s.eventCode == 2)
		GetWindow/Z kwTopWin wsize
		MoveWindow/W=$pName V_left, V_top, V_right - GSPNarrowHeight*mag*(-1)^!s.checked, v_bottom
	endif
	return 0
end
// axis off or on
Function Gaxis_OfforOn(ba) : ButtonControl
	STRUCT WMButtonAction &ba
	if (ba.eventCode != 2)
		return 0
	endif
//
	switch( ba.eventCode )
		case -1: // forced
		
		case 2: // mouse up
//			GetWindow/Z kwTopWin wsize
			strswitch(ba.userData)
				case "axisoff":
					Axisoff(1)
					Button AxisOffButton userData="axison"
					break
				case "axison":
					Axisoff(2)
					Button AxisOffButton userData="axisoff"
					break
			endswitch
			break
	endswitch
	return 0
End
// add or kill the colorscale
Function CSC_OfforOn(ba) : ButtonControl
	STRUCT WMButtonAction &ba
	if (ba.eventCode != 2)
		return 0
	endif
//
	String gName = getTopGraph()
	
	switch( ba.eventCode )
		case -1: // forced
		case 2: // mouse up
//			GetWindow/Z kwTopWin wsize
			strswitch(ba.userData)
				case "CSCoff":
					// kill
					ColorScale/w=$gName/K/N=CStext
					Button colorscaleNGpButton userData="CSCon"
					break
				case "CSCon":
					addcolorbar()
					Button colorscaleNGpButton userData="CSCoff"
					break
			endswitch
			break
	endswitch
	return 0
End
// bt in or out
Function Gbt_InorOut(ba) : ButtonControl
	STRUCT WMButtonAction &ba
	if (ba.eventCode != 2)
		return 0
	endif
//
	String gName = getTopGraph()	
	switch( ba.eventCode )
		case -1: // forced
		case 2: // mouse up
//			GetWindow/Z kwTopWin wsize
			strswitch(ba.userData)
				case "btin":
					ModifyGraph/w=$gName tick=2
					Button GraphbtLenButton userData="btout"
					break
				case "btout":
					ModifyGraph/w=$gName tick=0
					Button GraphbtLenButton userData="btin"
					break
			endswitch
			break
	endswitch
	return 0
End
//#########--**--        ------------------------------------------------          --**--#########
Function Frame_InorOut(ba) : ButtonControl
	STRUCT WMButtonAction &ba
	if (ba.eventCode != 2)
//		print 2
		return 0
	endif
//
	String gName = getTopGraph()
//	print gName
	switch( ba.eventCode )
		case -1: // forced
		case 2: // mouse up
//			GetWindow/Z kwTopWin wsize
			strswitch(ba.userData)
				case "frameoff":
					ModifyGraph/W=$gName framestyle = 0
					Button winFrameButton userData="frameon"
					break
				case "frameon":
					ModifyGraph/W=$gName framestyle = 1, frameInset = 0
					Button winFrameButton userData="frameoff"
					break
			endswitch
			break
	endswitch
	return 0
End
//#########--**--        ------------------------------------------------          --**--#########
// add tag or not
Function GTag_OfforOn(ba) : ButtonControl
	STRUCT WMButtonAction &ba
	if (ba.eventCode != 2)
		return 0
	endif
//
	String CtrlList 	= "", CtrlName = "", ValList = "", Others
	Variable i, Value = 0
	StrSwitch(ba.ctrlName)
		case "AddtagGpButton":
			AddTag(1)
			Button AddtagGpButton disable = 1
			Button offtagGpButton disable = 0
			break
		case "offtagGpButton":
			AddTag(2)
			Button offtagGpButton disable = 1
			Button AddtagGpButton disable = 0
			break
	endswitch
//
	return 0
End
//#########--**--        ------------------------------------------------          --**--#########
Function standoffControl(cb) : CheckBoxControl
	STRUCT WMCheckboxAction& cb
	if (cb.eventCode != 2)
		return 0
	endif
	if (ItemsinList(WinList("*", ";", "WIN:1")) == 0)	// make sure there is a graph to work with
		return 0
	endif
// bt in or out
	String gName = getTopGraph()
	ModifyGraph/W=$gName standoff = cb.checked
	FetchLatestGraphSizeValues()
End
//#########--**--        ------------------------------------------------          --**--#########
Function GSAlityControl(s) : ButtonControl
	STRUCT WMButtonAction &s
	if (s.eventCode != 2)
		return 0
	endif
	String gName = getTopGraph()
		
	String CtrlList 	= "", CtrlName = "", ValList = "", Others
	Variable i, Value = 0
	StrSwitch(s.ctrlName)
		case "CopyAllButton":
			CtrlList 	= ControlNameList("QGraphSizePanel", ";", "V*")
			CtrlList 	= RemoveFromList("VGraphWidth;VGraphHeight;",CtrlList)
			for (i = 0; i < ItemsInList(CtrlList); i += 1)
				CtrlName = StringFromList(i,CtrlList)
				ControlInfo/W=GraphSizePanel $CtrlName
				ValList += num2str(V_Value) + ";"
			endfor
			//
			Others = ""
			ControlInfo/W=GraphSizePanel SwapAxes
			Others 		+=  "SwapAxes:" + num2str(V_Value) + ";"
			ControlInfo/W=GraphSizePanel SizeUnit
			Others 		+=  "SizeUnit:" + num2str(V_Value) + ";"
			
			SetWindow GraphSizePanel ,userdata(CtrlSet)=CtrlList
			SetWindow GraphSizePanel ,userdata(ValSet)=ValList
			SetWindow GraphSizePanel ,userdata(OtherSet)=Others
			break
		case "PasteAllButton":
			CtrlList	= GetUserData("QGraphSizePanel", "", "CtrlSet")
			ValList		= GetUserData("QGraphSizePanel", "", "ValSet")
			Others		= GetUserData("QGraphSizePanel", "", "OtherSet")
			if (strlen(CtrlList) == 0)
				break
			endif
			CheckBox SwapAxes  ,win=GraphSizePanel	,value=str2num(StringByKey("SwapAxes", Others))
			PopupMenu SizeUnit ,win=GraphSizePanel	,mode=str2num(StringByKey("SizeUnit", Others))
			for (i = 0; i < ItemsInList(CtrlList); i += 1)
				CtrlName = StringFromList(i,CtrlList)
				Value 	= str2num(StringFromList(i,ValList))
				SetVariable $CtrlName ,win=GraphSizePanel ,value=_NUM:Value
				ExecuteVarChange(CtrlName, Value, 2)
			endfor
			break
		case "AxisOffButton":
			Axisoff(1)
			break
		case "AxisOnButton":
			Axisoff(2)
			break
		case "CalltracePanelButton":
//			QShowKBColorizePanel()
			Execute/P/Q/Z "INSERTINCLUDE \"KBColorizeTraces_Q\"";
			Execute/P/Q/Z "COMPILEPROCEDURES ";
			Execute/P/Q/Z "CreateKBColorizePanel()"
			break
		case "CalltraceToggleButton":
			CreateTogglerPanel()
		break
		case "CalltraceOffsetButton":  
			QAttachQuickScalePanel()
//			BuildTraceOffsetPanel()		// this section maybe cause stack crash:
			break
		case "CopySubwinAloneButton":   // CopySubwinAlone  
			DupGraSubW(gName)
			break
		case "renameNGpButton":   // CopySubwinAlone // printsubwinName 
			Qrenamegraph()
			break
		case "printsubwinName":
			print "\r//---current---//\r\t ", gname
			break
		case "CallSpliteAxisButton":	// CallSpliteAxisButton
			Dowindow/F $gName
			Execute/P/Q/Z "INSERTINCLUDE <Split Axis>";
			Execute/P/Q/Z "COMPILEPROCEDURES ";			
			Execute/P/Q/Z "WM_SplitAxisIModule#BuildSplitAxisPanel(WinName(0,1))"
			break
		case "CallcolorcontrolButton":	// CallSpliteAxisButton
			Execute/P/Q/Z "INSERTINCLUDE <Color Table Control Panel>";
			Execute/P/Q/Z "COMPILEPROCEDURES ";
			execute/P/Q/Z "WMColorTableControlPanel#createColorTableControlPanel()"
			break	
		case "CallUpdaterButton":
			Execute/P/Q/Z "INSERTINCLUDE \"Updater\"";
			Execute/P/Q/Z "COMPILEPROCEDURES ";
			execute/P/Q/Z "updater#makeInstallerPanel()"
			break
		case "legendNGpButton":		// CallSpliteAxisButton// colorscaleNGpButton
			Addlegend(1)
			break	
		case "CallSubWcontrolButton":	// 
//			BuildSubWinTBPanel()
			break
		case "goWebsiteButton":	// 
			print "\r//--**-- not a web project."
			break
		case "QWebButton":	//
			ToWebsite(1)
			break
		case "RestPoseButton":	// 
			RsetAllSubGraph()
			break
		case "releaseButton":	//
			String pathStr = SpecialDirPath("Igor Pro User Files",0,0,0) + "User Procedures:Graphsizepanel"
			NewPath/Q/Z/O/C texPath,pathStr
			openNotebook/K=1/W=(100,50,700,550)/P=texPath/N=GSReadMe ":GSrelease.txt"
			break
		case "KillSubwinAloneButton":	// 
			if(GrepString(gName,"#"))  	// work for SubWin Path
				String prompt
        		sprintf prompt, " Yes to Kill. \r No to cancel."
        		DoAlert 1, prompt
        		if (V_flag == 2)
            		Print "\r//--**-- Kill cancelled."
            		return -1           // Cancelled
        		endif
        		Killwindow $gName
			endif
		break
		default:
			break		
	EndSwitch
//
	FetchLatestGraphSizeValues()
End
//
static Function RsetAllSubGraph()
//	
	String prompt
	sprintf prompt, " Will post all subwindows to left top corner. Beyond Retrieve\r Yes or No ?"
	DoAlert/T="rePosi ......" 2, prompt
	if (V_flag > 1)
		Print "\r//--**-- rePosi cancelled."
		return -1        // Cancelled
	endif
//	
	String tophostgraph = winName(0,1)
	String SubwinList = ChildWindowList(tophostgraph)
//	print SubwinList
	String acSW = StringFromList(0, SubwinList)
	String gName = ""
	Variable i = 1
	do							// try the every avilable subwindw
		if (strlen(acSW) > 0)	// move to left top corner
//			print i				// for debug
			gName =tophostgraph+ "#" + acSW
			MoveSubwindow/w=$gName fnum = (10+i*10,0,120, 120)
								// will reset the size of the plot if auto size mode
		endif
		acSW = StringFromList(i, SubwinList)
		i += 1
	while (strlen(acSW) > 0)

	return 0					// end mission
End
//#########--**--        ------------------------------------------------          --**--#########
static Function AddTag(opts)
// bt in or out
	variable opts
	
	String gName = getTopGraph()
	string xVa_w_graph = QGetGraphSname()
//	string Str_w_grap = nameofWave(xVa_w_graph)
//	print Str_w_grap			//debug
	if (opts==1)
		TextBox/w=$gName/K/N=TGtext0
		TextBox/w=$gName/C/N=TGtext0/F=0/M/B=1/H=18/A=MC xVa_w_graph
		TextBox/w=$gName/C/N=TGtext0/X=37/Y=50
	elseif(opts==2)
		TextBox/w=$gName/K/N=TGtext0
	endif
end
//#########--**--        ------------------------------------------------          --**--#########
static Function Frameoff(opts)
// bt in or out
	variable opts
	
	String gName = getTopGraph()
	string xVa_w_graph = QGetGraphSname()
//	string Str_w_grap = nameofWave(xVa_w_graph)
//	print Str_w_grap			//debug

	if (opts==1 && GrepString(gName,"#"))
		ModifyGraph/W=$gName framestyle = 0
	elseif(opts==2 && GrepString(gName,"#"))
		ModifyGraph/W=$gName framestyle = 1, frameInset=1
	endif
end
//#########--**--        ------------------------------------------------          --**--#########
static Function Addlegend(opts)
// add legend for trace plot
	variable opts
	
	String gName = getTopGraph()
	string xVa_w_graph = QGetGraphSname()
//	string Str_w_grap = nameofWave(xVa_w_graph)
//		print Str_w_grap			//debug
	if (opts==1)
		Legend/w=$gName/K/N=LGtext0
		Legend/w=$gName/C/N=LGtext0/F=0/M/H=18/A=MC
		Legend/w=$gName/C/N=LGtext0/J/B=1/H=13
		Legend/w=$gName/C/N=LGtext0/J/X=30/Y=36
	elseif(opts==2)
		Legend/w=$gName/K/N=LGtext0
	endif
end
//#########--**--        ------------------------------------------------          --**--#########
static Function Addcolorbar()
// Add colorbar horiz or vert
	ControlInfo /W=$"QGraphSizePanel" VPlotWidth
	Variable graph_w = V_Value
	ControlInfo /W=$"QGraphSizePanel" VPlotHeight
	Variable graph_h = V_Value
	ControlInfo /W=$"QGraphSizePanel" standoffAxes
	Variable edgeoff = V_Value
	ControlInfo /W=$"QGraphSizePanel" colorscaleToHori
	Variable revCS = V_Value
	ControlInfo /W=$"QGraphSizePanel" QGraphThick
	Variable axisthick = V_Value
	
	variable width = 8
	variable height = graph_h-0.6*axisthick
	variable distance = 100.6 + 0.5*axisthick
	
	if(axisthick<1)
		axisthick = axisthick+ 0.2*0.7/axisthick
	endif
//	print edgeoff, axisthick   // for debug
	if(edgeoff)
		height = height + 1.4*axisthick
		
		distance = distance + axisthick
	endif
	Qcolorbar(8,height,distance,0,revCS);
	
	if (revCS)
		distance = 100.4 + 0.3*axisthick
		Qcolorbar(height-graph_h+graph_w,width,0,distance,revCS); //  1: vert       0:
	endif
end
//#########--**--        ------------------------------------------------          --**--#########
static Function Qcolorbar(x,y,m,n,vert_tag)
// 	colorbar size and position,vert_tag:: 0:vert   1:horizont
//	exam::  Qcolorbar(150,8,0,101,1);
	variable x,y	// "width",  "height"
	variable m,n	// "position",x-posi,y-posi
	variable vert_tag
	
	ControlInfo /W=$"QGraphSizePanel" QGraphThick
	variable framesize = V_Value
	ControlInfo /W=$"QGraphSizePanel" VGraphFont
	variable fontsize = V_Value
	//
	String gName = getTopGraph()
	
	wave xVa_w_graph
	wave xVa_w_graph = QGetImageref()
	string Str_w_grap = nameofWave(xVa_w_graph)
	//
	string fontsname = "Times New Roman"
	
	variable tickOff = 0.1
	if(framesize<0.3)
		tickOff = 0
	endif

	// add the colorbar for current graph window
	ColorScale/w=$gName/K/N=CStext
	ColorScale/w=$gName/C/N=CStext image=$Str_w_grap
	ColorScale/w=$gName/C/N=CStext vert=(1-vert_tag),side=(vert_tag+1);
	ColorScale/w=$gName/C/N=CStext width=x,height=y;
	ColorScale/w=$gName/C/N=CStext font=fontsname,fsize=fontsize;
	ColorScale/w=$gName/C/N=CStext/B=1/D=1.2 frame=(framesize - tickOff);DelayUpdate
	ColorScale/w=$gName/C/N=CStext tickLen=1.10,tickThick=(framesize - tickOff),nticks=3
	ColorScale/w=$gName/C/N=CStext/F=0
	
	if(vert_tag)
		ColorScale/w=$gName/C/N=CStext/A=MB/X=(m)/Y=(n)
	else
		ColorScale/w=$gName/C/N=CStext/A=LC/X=(m)/Y=(n)
	endif
End
//#########--**--        ------------------------------------------------          --**--#########
static function Axisoff(vopt)
	variable vopt
	String gName = getTopGraph()
// bt in or out	
	if ((vopt & 2^0) !=0)
		ModifyGraph/w=$gName axThick=0
		ModifyGraph/w=$gName tick=3,noLabel=2
	endif
// bt in or out
	if ((vopt & 2^1) !=0)
		ModifyGraph/w=$gName axThick=0.6, btThick=0.6
		ModifyGraph/w=$gName tick=2,noLabel=0
	endif
	//
end
//#########--**--		----------
static function ToWebsite(Vpts)
	variable Vpts
	string url

	switch(Vpts)
		case 0:
		url = "https://www.wavemetrics.com/node/21562"
		break
		case 1:
		url = "https://www.bilibili.com/"
		break
	endswitch
	
	browseURL/Z  url
end
//#########--**--        ------------------------------------------------          --**--#########
static function /DF getNewnameDFR()
    NewDataFolder/O root:Packages
    NewDataFolder/O root:Packages:NewnameDFR
    DFREF dfr = root:Packages:NewnameDFR
    return dfr
end
// bt in or out
static function /S QGetGraphSname()
	String gName = getTopGraph()
	String s=ImageNameList(gName,";")
//	print s		//debug
	string list = ""
	if(strlen(s)==0)
		s = traceNameList(gName,";",1)
//		StringFromList(items-1 - i,list)
//		print list			//debug
	endif
//	print strlen(s)
	return s
End
//#########--**--        ------------------------------------------------          --**--#########
static Function DupGraSubW(gname)
	String gname

    if(stringmatch(gName, "*#*") ==0)
    	return 0
    endif  
    //    
    String rec = WinRecreation(gname, 0)   
    Variable lines=ItemsInList(rec, "\r")
    Variable i
    String newrec=""
    for (i = 0; i < lines; i+=1)
        String oneline = StringFromList(i, rec, "\r")
        if (StringMatch(oneline, "*Display*"))
            oneline = RemoveSlashW(oneline)
            oneline = RemoveSlashHost(oneline)
        endif
        newrec += oneline+"\r"
    endfor
    Execute/Z newrec
    print "\r//--**-- Copy SunWindow to standalone: " + gName   // for debug
end
//
static Function/S RemoveSlashW(aLine)
	String aLine

    String newstr = ""
    if (StringMatch(aLine, "*/W=*"))
        Variable pos1 = StrSearch(aLine, "/W=", 0)
        Variable pos2 = StrSearch(aLine, ")", pos1)
        newstr = aLine[0,pos1-1]
        newstr += aLine[pos2+1,strlen(aLine)]
    endif
   	//
    return newstr
end
//
static Function/S RemoveSlashHost(aLine)
	String aLine
	
    String newstr = ""
    if (StringMatch(aLine, "*/HOST=*"))
        Variable pos1 = StrSearch(aLine, "/HOST=", 0)
        Variable pos2 = StrSearch(aLine, " ", pos1)     
        // This fails if there is another flag after /HOST=...
        newstr = aLine[0,pos1-1]
        newstr += aLine[pos2,strlen(aLine)]
    endif
//
    return newstr
end
//#########--**--        ------------------------------------------------          --**--#########
Function QShowKBColorizePanel()
	String topGraphHost=KBActiveGraphHost()
	String topgraphName = winName(0,1)
	DoWindow/F KBColorizePanel
	if (V_Flag == 0)
		execute/Q/Z/P "CreateKBColorizePanel()"
	endif		
//	if( strlen(topgraphName) )
//		AutoPositionWindow/M=0/R=$topgraphName KBColorizePanel
//	endif
	if (ItemsinList(WinList("*", ";", "WIN:1")) == 0)
		Abort "No graphs available. Create a graph first."
	endif
End
//#########--**--        ------------------------------------------------          --**--#########
//		Rename Graph    Added by Q
//#########--**--        ------------------------------------------------          --**--#########
static Function Qrenamegraph()
	string oldname = getTopGraph()
	string newname = oldname
	
	string Str_w_grap, str_M
	variable pos1
//
	if(GrepString(oldname,"#"))
		pos1 = StrSearch(oldname, "#", inf, 1)
// 
		str_M = oldname[0, pos1]
		newname = oldname[pos1+1, inf]
//        print  pos1, pos2		// for debug
	endif
	
	prompt newname , "new name for Graph"
	doprompt "Rename Graph", newname
	newname = CleanupName(newname, 0)
//
	if(stringmatch(newname, oldname))
		print "\r//--**-- Rename Graph: ", "nothing changed."
	else
		RenameWindow $oldname $newname
		print "\r//--**-- Rename Graph: ", oldname, "to ", newname
	endif
end
//#########--**--        ------------------------------------------------          --**--#########
static Function/wave QGetImageref()
	String gName = getTopGraph()
	String s=ImageNameList(gName,";")
	//
	if(strlen(s)==0)
		s=traceNameList(gName,";",0)
		Wave w=TraceNameToWaveRef("",StringFromList(0,s))
	endif
	//
	if(strlen(s)!=0)
		Wave w=ImageNameToWaveRef("",StringFromList(0,s))
	endif
	//
	return w 
End 
//#########--**--        ------------------------------------------------          --**--#########
//	tracer toggler		-- https://www.wavemetrics.com/code-snippet/trace-toggler
//#########--**--        ------------------------------------------------          --**--#########
function CreateTogglerPanel()
	String topGraph = getTopGraph()
    string trl=tracenamelist(topGraph,";",1) 		//list of all traces on graph
    string vtrl=tracenamelist(topGraph,";",1+4) 	//list of visible traces on graph
    string item,itemname,itemnameinfo
    variable items=itemsinlist(trl),i,Vitems=itemsinlist(Vtrl)
    string ttlabel=":: "+topGraph + "	:: " + num2str(items) + " traces" + "	:: " + num2str(Vitems) + " visible"//WinName(0,1)
    string ttwinname="tt"+"Toggle_Traces"
    string pName = "ttToggle_Traces"
//
    DoWindow/K $ttwinname
    variable max_row = TTgglemax_row   //	max trace per column
    variable extraV = 340	//	interval between cols
    
//    variable P_w = 550  		//   width of toggle panel
//    variable max_col = floor(items/max_row - 1)
//    max_col = max_col <=0 ? 1 : max_col
//    print max_col
    
    variable P_H = items-1   	//   height of toggle panel
    if(items>max_row+1)
    	P_H = max_row
    endif
    variable line_H = 18
    	
    NewPanel/W=(800,70,50+800,90+(P_H+1)*line_H+70)/N=$ttwinname/K=1 as "Toggle Traces"
	
	String MMGraph = WinName(0,1)
	
	
	variable P_ritio = 1

#if IgorVersion() > 7
	P_ritio = ScreenResolution/PanelResolution(MMGraph)	
//	print P_ritio
#endif
    
    if(strlen(topGraph))
        AutoPositionWindow/M=0/R=$MMGraph $ttwinname
    endif
//    SetWindow $ttwinname hook(UpdateHook)=togglerUpdateFunc
//    ModifyPanel/W=$ttwinname noEdit=1, fixedSize=0
    SetVariable GraphName  title="GN"	,pos ={25 , 34}	,size={25,24},fColor=(65535,0,26214),value=_STR:topGraph,disable = 1
	Button showGrah 	,pos={4 ,4}		,size={25 , 22}	,proc=showtiedgraph	,title="CT",fColor=(29524,1,58982),help = {"show the tied graph"}
    TitleBox tb1		,pos={32,15}	,size={0  ,  0}	,anchor=LC,title=ttlabel,labelBack=(65535,49151,62258)
//	Create a checkbox for each trace, checked if visible and unchecked if already hidden
	
	if(items<(max_row+1))
	    Button closeme 		,pos={5  ,37 + items*line_H}		,size={60 , 21},proc=endTraceToggler	,title="Show All",userdata=ttwinname
		Button ResetTG 		,pos={70 ,37 + items*line_H}		,size={60 , 21},proc=endTraceToggler3	,title="ReCheck",userdata=ttwinname,fColor=(65535,0,52428)
		Button closeme2 	,pos={5  ,63 + items*line_H}		,size={125, 21},proc=endTraceToggler2	,title="Close without reset",userdata=ttwinname
    	Button TGcolor 		,pos={135 ,37 + items*line_H}		,size={105, 21},proc=TraceTGcolorbar	,title="Build Color Wave",userdata=ttwinname
    	Button TGcoloradd 	,pos={135 ,63 + items*line_H}		,size={105, 21},proc=TraceTGcolorbar2	,title="add trace colorbar",userdata=ttwinname
    	CheckBox colorreverse, pos={245, 66 + items*line_H}		,title="color reverse",value=0//,fColor=(VR, VG, VB)
    else
    	Button closeme 		,pos={5  ,37 +(max_row+1)*line_H}	,size={60 , 21},proc=endTraceToggler	,title="Show All",userdata=ttwinname
		Button ResetTG 		,pos={70 ,37 +(max_row+1)*line_H}	,size={60 , 21},proc=endTraceToggler3	,title="ReCheck",userdata=ttwinname,fColor=(65535,0,52428)
		Button closeme2 	,pos={5  ,63 +(max_row+1)*line_H}	,size={125, 21},proc=endTraceToggler2	,title="Close without reset",userdata=ttwinname
		Button TGcolor 		,pos={135 ,37 + (max_row+1)*line_H}	,size={105, 21},proc=TraceTGcolorbar	,title="Build Color Wave",userdata=ttwinname
    	Button TGcoloradd 	,pos={135 ,63 + (max_row+1)*line_H}	,size={105, 21},proc=TraceTGcolorbar2	,title="add trace colorbar",userdata=ttwinname
		CheckBox colorreverse, pos={245, 66 + (max_row+1)*line_H}	,title="color reverse",value=0//,fColor=(VR, VG, VB)
	endif
//   
    string infoTrace
    variable extra = 0
    variable j = 0
    string v_RGB
    variable VR, VG, VB		// color of the trace
    variable Vlenmax = 61
    for(i=0;i<items;i+=1)
        item = stringfromlist(i,trl)
        if(strlen(item) == 0)
        	return 0
        endif
        //print item
        itemname = replacestring("'",item,"")
        itemnameinfo = itemname
        infoTrace =  TraceInfo(topGraph,item,0) 		//remove ugly single quotes for label
//        print infoTrace
        itemnameinfo += " VS "
        itemnameinfo += StringByKey("XWAVE", infoTrace, ":", ";")
        itemnameinfo += "  XA: "
        itemnameinfo += StringByKey("XAXIS", infoTrace, ":", ";")
        itemnameinfo += "  YA: "
        itemnameinfo += StringByKey("YAXIS", infoTrace, ":", ";")
        
        v_RGB = StringByKey("rgb(x)", infoTrace, "=", ";")
        v_RGB = replacestring(",",v_RGB,";")
        v_RGB = replacestring(")",v_RGB,";")
        v_RGB = replacestring("(",v_RGB,"")
//        print v_RGB    //   turn to list
        VR = str2num(stringfromlist(0,v_RGB))
        VG = str2num(stringfromlist(1,v_RGB))
        VB = str2num(stringfromlist(2,v_RGB))      
//        print VR, VG, VB
        j = i

        if((max_row<i)&(i<2*max_row + 2))
        	extra = extraV * 1
        	j = i - max_row - 1
        elseif((i>2*max_row+1)&(i<3*max_row+3))
        	extra = extraV * 2
        	j = i - 2*max_row-2
        elseif((i>3*max_row+1)&(i<4*max_row+4))
        	extra = extraV * 3
        	j = i - 3*max_row-3
        elseif(i>4*max_row+2)
        	extra = extraV * 4
        	j = i - 4*max_row-4
        endif
        variable Vlen = strlen(itemnameinfo)
        Vlenmax = Vlenmax < Vlen ? Vlen : Vlenmax
//        print Vlen, Vlenmax
//        Vlenmax = Vlen

    	SetVariable $("setvar" + num2str(i)) pos={82 + extra,31+j*line_H}, size={Vlenmax^1.35*1.20,18},limits={-inf,inf,0}, frame=0,valueColor=(VR, VG, VB), value = _STR:itemnameinfo
//    	SetVariable $("setvar" + num2str(i)) pos={82 + extra,31+j*line_H}, size={0,0},limits={-inf,inf,0}, frame=0,valueColor=(VR, VG, VB), value = _STR:itemnameinfo
    	TitleBox $("title"+num2str(i)) title=num2str(i),pos={6 + extra,30+j*line_H},anchor=RC,frame=0, fSize=14, fixedSize=1,size={20,19}
    	
    	Button $("bottonD"+num2str(i))	,pos={30 + extra, 33+j*line_H},size={16,15},title="X",proc=QDeleteTrace	,userdata=item,fColor=(52428,1,1),valueColor=(65535,65535,65535),help={"delete trace on graph."}
    	Button $("bottonC"+num2str(i))	,pos={49 + extra, 33+j*line_H},size={16,15},title="C",proc=QCopyTrace	,userdata=item,fColor=(65535,54607,32768),help={"copy trace to clip."}
      	
      	if (stringmatch(vtrl,"*"+item+";"+"*"))  	// ";" make sure the full trace name comparison, good!!!
            CheckBox $("box"+num2str(i)) pos={68 + extra,34+j*line_H}	,value=1,	proc=ToggleTrace,userdata=item,title=""//,fColor=(VR, VG, VB)
        	SetVariable $("setvar" + num2str(i)) fstyle = 1
        else
            CheckBox $("box"+num2str(i)) pos={68 + extra,34+j*line_H}	,value=0,	proc=ToggleTrace,userdata=item,title=""//,fColor=(VR, VG, VB)
        	SetVariable $("setvar" + num2str(i)) fstyle = 2
        endif
    
    
    endfor
//        print Vlenmax
    GetWindow/Z $ttwinname wsize
    MoveWindow/W=$ttwinname V_left, V_top, V_left+100+(Vlenmax)*4*P_ritio, v_bottom
    ModifyPanel /W=$ttwinname, cbRGB=(65534,65534,65534)
//    
#if IgorVersion() > 9
if( PanelResolution(ttwinname) == 72 )
	ModifyPanel /W=$ttwinname ,expand = 1.15 //  requires igor9, 
else
	ModifyPanel /W=$ttwinname ,expand = 1.5 //  requires igor9, 
endif
#endif
	return 0
end
//
Function ToggleTrace(cba) : CheckBoxControl
    STRUCT WMCheckboxAction &cba
    string tracename=cba.userdata
    string checkTitle = cba.ctrlName
    variable ii = str2num(checkTitle[3, inf])
//    print checkTitle, ii		// for debug
//   	String topGraph = getTopGraph()
   	string pName = "ttToggle_Traces"
   	
   	string gName
   	ControlInfo/W=$pName GraphName
   	gName = S_Value
//	print gName
    switch(cba.eventCode)
        case 2: // mouse up
            Variable checked = cba.checked
            If (checked==1)
                ModifyGraph/W=$gName hideTrace($tracename)=0
                SetVariable $("setvar" + num2str(ii))	fstyle = 1
            Else
                ModifyGraph/W=$gName hideTrace($tracename)=2
                SetVariable $("setvar" + num2str(ii))	fstyle = 2
            endif
            break
        case -1: // control being killed
            break
    endswitch
//
    return 0
End
//
function QCopyTrace(cba) :  ButtonControl
    
    STRUCT WMButtonAction &cba
    if (cba.eventCode != 2)
		return 0
	endif
    string tracename=cba.userdata
//   	String topGraph = getTopGraph()
    string pName = "ttToggle_Traces"
   	
   	string gName
   	ControlInfo/W=$pName GraphName
   	gName = S_Value
	
//	print gName
    if (cba.eventcode==2)
        wave w = TraceNameToWaveRef(gName,tracename)   
   		string s = "YWAVE:" + GetWavesDataFolder(w,4) + ";" + TraceInfo(gName,tracename,0)
    	PutScrapText s
//    print "s = ", s
    endif
end
//
function QDeleteTrace(cba) :  ButtonControl
    STRUCT WMButtonAction &cba
    string botton = cba.ctrlName
    if (cba.eventCode != 2)
		return 0
	endif
    string tracename = cba.userdata
    string pName = "ttToggle_Traces"
//   	print botton
   	variable i = str2num(botton[7, strlen(botton)])
//   	print i
   	
   	string gName
   	ControlInfo/W=$pName GraphName
   	gName = S_Value
    if (cba.eventcode==2)
        String prompt
		sprintf prompt, "Will delete the chossed trace. Beyond Retrieve\r Yes or No ?"
		DoAlert/T="Delete trace ......" 2, prompt
		if (V_flag > 1)
			Print "\r//--**-- operation cancelled."
			return -1        // Cancelled
		endif
             
        wave w = TraceNameToWaveRef(gName,tracename)   
		RemoveFromGraph/W=$gName $tracename 
		
		CheckBox 	$("box"+num2str(i)) 		disable=1
       	TitleBox 	$("title"+num2str(i))  		disable=1
    	Button 		$("bottonD"+num2str(i))  	disable=1
    	Button 		$("bottonC"+num2str(i))  	disable=1
    	SetVariable $("setvar" + num2str(i))	disable=1
//    print "s = ", s
    endif
end
//
Function endTraceToggler(cba): ButtonControl
    struct WMButtonAction &cba
    if (cba.eventCode != 2)
		return 0
	endif
    string ttwinname=cba.userdata
   	string pName = "ttToggle_Traces"
   	
   	string gName
   	ControlInfo/W=$pName GraphName
   	gName = S_Value
    if (cba.eventcode==2)
//        DoWindow/K $ttwinname
        ModifyGraph/W=$gName hideTrace=0
    endif
End
//
Function showtiedgraph(cba): ButtonControl
    struct WMButtonAction &cba
    if (cba.eventCode != 2)
		return 0
	endif
    string ttwinname=cba.userdata
   	string pName = "ttToggle_Traces"
   	
   	string gName
   	ControlInfo/W=$pName GraphName
   	gName = S_Value
    if (cba.eventcode==2)
//        DoWindow/K $ttwinname
		Dowindow/F $gName	// ensure that
    endif
End
//
Function endTraceToggler2(cba): ButtonControl
    struct WMButtonAction &cba
    if (cba.eventCode != 2)
		return 0
	endif
    string ttwinname=cba.userdata
    if (cba.eventcode==2)
        DoWindow/K $ttwinname
    endif
End
//
Function endTraceToggler3(cba): ButtonControl
    struct WMButtonAction &cba
    if (cba.eventCode != 2)
		return 0
	endif
    string ttwinname=cba.userdata
    
    if (cba.eventcode==2)
        CreateTogglerPanel()
    endif
End
//
Function TraceTGcolorbar(cba) : ButtonControl
// generate the color wave for buiding the colorbar
	struct WMButtonAction &cba
    if (cba.eventCode != 2)
		return 0
	endif
	string pName = "ttToggle_Traces"
	
	String topGraph = getTopGraph()
    string trl=tracenamelist(topGraph,";",1) 		//list of all traces on graph
    string vtrl=tracenamelist(topGraph,";",1+4) 	//list of visible traces on graph
    string item,itemname,itemnameinfo
    variable items=itemsinlist(trl),Vitems=itemsinlist(Vtrl),i,j=0
//
	String traceRGB = topGraph + "_traceRGB"
	String traceRGBTG = topGraph + "_traceRGBTG"
	String traceRGBPosi = topGraph + "_traceRGBPosi"
    
    make/O/n=(Vitems,3)  $traceRGB = x
    make/O/T/n=(Vitems)  $traceRGBTG
    make/O/n=(Vitems)  $traceRGBPosi
    
    wave colorWave = $traceRGB
    wave/T textWave = $traceRGBTG
    wave posiWave = $traceRGBPosi

	if (cba.eventcode==2)
//	    variable TG_step = 100/items	//igor9
		variable TG_step = 1	// igor6 
	    String V_RGB
	    string infoTrace
	    variable VR, VG, VB		// color of the trace
	    for(i=0;i<items;i+=1)
	        item = stringfromlist(i,trl)
	        if(strlen(item) == 0)
	        	return 0
	        endif
//	        print item
	        itemname = replacestring("'",item,"")
	        infoTrace =  TraceInfo(topGraph,item,0) 		//remove ugly single quotes for label
			
			if (stringmatch(vtrl,"*"+item+";"+"*"))  	// ";" make sure the full trace name comparison, good!!! only for visible traces
            	v_RGB = StringByKey("rgb(x)", infoTrace, "=", ";")
		        v_RGB = replacestring(",",v_RGB,";")
		        v_RGB = replacestring(")",v_RGB,";")
		        v_RGB = replacestring("(",v_RGB,"")
		//        print v_RGB    //   turn to list
		        VR = str2num(stringfromlist(0,v_RGB))
		        VG = str2num(stringfromlist(1,v_RGB))
		        VB = str2num(stringfromlist(2,v_RGB))      
		//	        print VR, VG, VB
				colorWave[j][0] = VR
				colorWave[j][1] = VG
				colorWave[j][2] = VB
		//			posiWave[j] = TG_step/2 + j*TG_step	// in igor9
				posiWave[j] = j		// in igor6
//				textWave[j] = itemname
        		j += 1
        	endif			
    	endfor
    	edit/K=1 colorWave, textWave, posiWave
    endif
end 
Function TraceTGcolorbar2(cba) : ButtonControl
	struct WMButtonAction &cba
    if (cba.eventCode != 2)
		return 0
	endif
	string pName = "ttToggle_Traces"
	
	String topGraph = getTopGraph()
    string trl=tracenamelist(topGraph,";",1) 		//list of all traces on graph
    string vtrl=tracenamelist(topGraph,";",1+4) 	//list of visible traces on graph
    string item,itemname,itemnameinfo
    variable items=itemsinlist(trl),Vitems=itemsinlist(Vtrl),i,j=0
//
	String traceRGB = topGraph + "_traceRGB"
	String traceRGBTG = topGraph + "_traceRGBTG"
	String traceRGBPosi = topGraph + "_traceRGBPosi"
    
    make/O/n=(Vitems,3)  $traceRGB
    make/O/T/n=(Vitems)  $traceRGBTG
    make/O/n=(Vitems)  $traceRGBPosi
    ControlInfo/W=$pName colorreverse
    Variable Re_S = V_Value	
    
    wave colorWave = $traceRGB
    wave/T textWave = $traceRGBTG
    wave posiWave = $traceRGBPosi
	
	if (cba.eventcode==2)
//	    variable TG_step = 100/items	//igor9
		variable TG_step = 1	// igor6 
	    String V_RGB
	    string infoTrace
	    variable VR, VG, VB		// RGB color of the trace
	    for(i=0;i<items;i+=1)
	        item = stringfromlist(i,trl)
	        if(strlen(item) == 0)
	        	return 0
	        endif
//	        print item
	        itemname = replacestring("'",item,"")
	        infoTrace =  TraceInfo(topGraph,item,0) 		//remove ugly single quotes for label
			
			if (stringmatch(vtrl,"*"+item+";"+"*"))  	// ";" make sure the full trace name comparison, good!!!
            	v_RGB = StringByKey("rgb(x)", infoTrace, "=", ";")
		        v_RGB = replacestring(",",v_RGB,";")
		        v_RGB = replacestring(")",v_RGB,";")
		        v_RGB = replacestring("(",v_RGB,"")
		//        print v_RGB    //   turn to list
		        VR = str2num(stringfromlist(0,v_RGB))
		        VG = str2num(stringfromlist(1,v_RGB))
		        VB = str2num(stringfromlist(2,v_RGB))      
		//	        print VR, VG, VB
				colorWave[j][0] = VR
				colorWave[j][1] = VG
				colorWave[j][2] = VB
		//			posiWave[j] = TG_step/2 + j*TG_step	// in igor9
				posiWave[j] = j		// in igor6
//				textWave[j] = itemname
        		j += 1
        	endif			
    	endfor
    	Addcolorbar()
// igor9   	
//    	ColorScale/C/N=CStext/F=0/B=1/D=1.2 frame=0.60, ctab={0,100,colorWave,1},userTicks={posiwave,textWave}

//igor6
		ColorScale/w=$topGraph/C/N=CStext cindex=colorWave, axisRange={-0.5,j-0.5,!Re_S}
		ColorScale/w=$topGraph/C/N=CStext userTicks={posiwave,textWave}
    endif
end 
//#########--**--        ------------------------------------------------          --**--#########
static Function SetAxisLabelsAndTicks(axName, gName, off)
	String axName, gName
	Variable off
	if (FindListItem(axName,AxisList(gName)) > -1)
//		ModifyGraph/W=$gName tick($axName)=3*off
		ModifyGraph/W=$gName noLabel($axName)=2*off
//		ModifyGraph/W=$gName margin($axName)=25*off
		ControlInfo/W=GraphSizePanel cPrint
		if (V_Value)
			print "•ModifyGraph tick("+axName+")="+num2str(3*off)+", noLabel("+axName+")="+num2str(2*off)//+", margin("+axName+")="+num2str(25*off)
		endif
	endif
	return 0
End
//#########--**--        ------------------------------------------------          --**--#########
Function Gsize_CopyPaste(s) : ButtonControl
	STRUCT WMButtonAction &s
	if (s.eventCode != 2)
		return 0
	endif
	String gName = getTopGraph()
	if (!strlen(gName))
		return 0
	endif
	String topLevelgName = StringFromList(0, gName, "#")
	string ori_str = WinName(0,1) // only graph
	

	String cName = "", CtrlList = "", ValList = "", Others = "", AxisSet = "", Style = ""
	Variable i
	StrSwitch(s.ctrlName)    //  
		case "ResetAllButton":
			ModifyGraph/W=$gName/Z width=0, height=0, margin=0
			ModifyGraph/W=$gName/Z gfSize=0, fSize=0, lblMargin=0, tlOffset=0
			//ModifyGraph/W=$gName/Z tick=0,noLabel=0, swapXY=0, expand=0
		break	
		case "ModifyNGpButton":
			Dowindow/F $ori_str	// ensure that
			
			execute/Q/P "DoIgorMenu \"Graph\",\"Modify Graph\""   //  write here example
		break	
		case "CatchNGpButton":  //	print current graph name 
//			printf "\r//--**-- current graph is: %s", gName
//			SavePICT/win=$gName/E=-5/RES=300/TRAN=1 as "Clipboard"

			Dowindow/F $ori_str	// ensure that
//
		break
		case "CopyAllButton":
			CtrlList = ControlNameList(s.win, ";", "*Axis_*")
			for (i = 0; i < ItemsInList(CtrlList); i += 1)
				ControlInfo/W=$(s.win) $StringFromList(i,CtrlList)
				AxisSet += StringFromList(i,CtrlList) + ":" + num2str(V_Value) + ";"
			endfor
			
			CtrlList = ControlNameList(s.win, ";", "V*")
			CtrlList = RemoveFromList("VGraphWidth;VGraphHeight;",CtrlList)
			for (i = 0; i < ItemsInList(CtrlList); i += 1)
				ControlInfo/W=$(s.win) $StringFromList(i,CtrlList)
				ValList += num2str(V_Value) + ";"
			endfor
			ControlInfo/W=$(s.win) SwapAxes;		Others +=  "SwapAxes:" + num2str(V_Value) + ";"
			ControlInfo/W=$(s.win) SizeUnit;		Others +=  "SizeUnit:" + S_Value + ";"
//			ControlInfo/W=$(s.win) AspectSelect;	Others +=  "Aspect:" + S_Value + ";"
			ControlInfo/W=$(s.win) FormatSelect;	Others +=  "Format:" + S_Value + ";"
		
			SetWindow $(s.win) ,userdata(CtrlSet)=CtrlList				// saved in the panel's user data
			SetWindow $(s.win) ,userdata(ValSet)=ValList
			SetWindow $(s.win) ,userdata(OtherSet)=Others
			SetWindow $(s.win) ,userdata(AxesSet)=AxisSet
		break
		case "PasteAllButton":	
			Others   = GetUserData(s.win, "", "OtherSet")
			AxisSet	 = GetUserData(s.win, "", "AxesSet")
			if (strlen(Others) == 0)
				break
			endif
			Variable swap = str2num(StringByKey("SwapAxes", Others))
			CheckBox SwapAxes  		,win=$(s.win)	,value=swap
			PopupMenu SizeUnit 		,win=$(s.win)	,popMatch=StringByKey("SizeUnit", Others)
//			PopupMenu FormatSelect	,win=$(s.win)	,popMatch=StringByKey("Format", Others)
//			PopupMenu AspectSelect	,win=$(s.win)	,popMatch=StringByKey("Aspect", Others)

			Variable cValue
			CtrlList = ControlNameList(s.win, ";", "cAxis_*")
			for (i = 0; i < ItemsInList(CtrlList); i += 1)
				cName	= StringFromList(i,CtrlList)
				cValue	= str2num(StringByKey(cName, AxisSet)) == 0
				SetAxisLabelsAndTicks(ReplaceString("cAxis_",cName,""), gName, cValue)
			endfor
			
			CtrlList = ControlNameList(s.win, ";", "tlAxis_*")+ControlNameList(s.win, ";", "alAxis_*")
			for (i = 0; i < ItemsInList(CtrlList); i += 1)
				cName	= StringFromList(i,CtrlList)
				cValue	= str2num(StringByKey(cName, AxisSet))
				SetVariable $cName	,win=$(s.win) ,value=_NUM:cValue
				ControlInfo/W=$(s.win) $cName
				if (V_disable == 0)
					ExecuteVarChange(cName, cValue, 2)
				endif
			endfor
			
			CtrlList = GetUserData(s.win, "", "CtrlSet")
			ValList	 = GetUserData(s.win, "", "ValSet")
			for (i = 0; i < ItemsInList(CtrlList); i += 1)
				cName  = StringFromList(i,CtrlList)
				cValue = str2num(StringFromList(i,ValList))
				SetVariable $cName	,win=$(s.win) ,value=_NUM:cValue
				ExecuteVarChange(cName, cValue, 2)
			endfor
			
			ModifyGraph/W=$gName/Z swapXY=swap
			String aspect = StringByKey("Aspect", Others)
			if (!StringMatch(aspect,"Free"))					// actually apply aspect ratio setting as well (should come after swapXY)
			endif
		break
		case "ApplyButton":										// applies selected graph style
			String dfSav= GetDataFolder(1)
			SetDataFolder root:									// go back to root, in case for same wave in other folder
			
			ControlInfo/W=$(s.win) GrStyle
			Style = S_value
			String Last = WinRecreation(topLevelgName,0)
			Variable noRevert = (StringMatch(Last,"*TransformMirror*") || StringMatch(Last,"*AxisTransform*"))	// graphs with a transformed axis cannot be recreated
			if (noRevert)
				DoAlert 1, "Reverting the graph will not be possible. Apply anyway?"
				if (V_flag != 1)
					break
				endif
			endif
			Variable doStyle = StringMatch(Style,"CStyle*") ? 1 : (StringMatch(Style,"From Clipboard*") ? 2 : 0)
			
			ControlInfo/W=$(s.win) cPrint
			Variable doPrint = (V_Value && V_flag == 2)
			DoWindow/F $topLevelgName															// make sure the window is in front for the macro to work on
			Switch (doStyle)
				case 1:	// copied style
					Style = GetUserData(s.win, "", "CopyStyle")
					for (i = 0; i < ItemsInList(Style); i += 1)
						Execute/Q StringFromList(i,Style)
						if (doPrint)
							print "•"+StringFromList(i,Style)
						endif
					endfor
				break
				case 2:	// clipboard style
					Style = GetScrapText()
					if (!StringMatch(Style,"*ModifyGraph*"))
						DoAlert 0, "It seems there are no valid style commands in the clipboard.\r\rTry to first copy a style (e.g., by using Copy Style while holding Shift)."
					endif
					Style = Gsize_cleanupMacro(Style)
					Style = ReplaceString("\r", Style, ";")
					for (i = 0; i < ItemsInList(Style); i += 1)
						Execute/Q/Z StringFromList(i,Style)
						if (doPrint && V_flag == 0)
							print "•"+StringFromList(i,Style)
						endif
					endfor
				break
				default:
					if (strlen(Style))
						Execute/Q Style+"()"
						if (doPrint)
							print "•"+Style+"()"
						endif
					endif
				break
			EndSwitch
			DoWindow/F $(s.win)
			
			if (!noRevert)
				SetWindow $(s.win), userdata(LastgName)=topLevelgName		// save into panel's user data
				SetWindow $(s.win), userdata(LastStyle)=Last
			endif
			Execute/P/Q "SetDataFolder " + dfSav
		break
		case "RevertButton":												// copies top-graph's style
			Style = GetUserData(s.win, "", "LastStyle")						// check for existence of backup style
			if (strlen(Style) > 0)
				KillWindow $topLevelgName
				String/G ExeCmd = Style
				Execute/P/Q "Execute ExeCmd"
				Execute/P/Q "KillStrings/Z ExeCmd"
			endif
		break
		case "CopyStyleButton":												// copies style of selected graph
			Style = WinRecreation(gName,1)
			String childList = ChildWindowList(gName), childStyle = ""							// need to clean the style macro of any subwindow styles (won't work anyway)
			for (i = 0; i < ItemsInList(childList); i += 1)
				childStyle = WinRecreation(gName+"#"+StringFromList(i,childList),1)
				childStyle = RemoveListItem(0,childStyle, "\r")									// remove "proc" line
				childStyle = RemoveListItem(0,childStyle, "\r")									// remove "pauseupdate" line
				childStyle = RemoveListItem(ItemsInList(childStyle,"\r") - 1,childStyle, "\r")	// remove "endmacro" line
				Style = ReplaceString(childStyle,Style,"")										// remove child window style
			endfor
//			print Style
			Style = Gsize_cleanupMacro(Style)
//			print Style
			ControlInfo/W=$(s.win) CopyAxes														// include axes if checkbox is active
			if (!V_Value)
				Style = GrepList(Style, "^(SetAxis)", 1, "\r")
			endif
			ControlInfo/W=$(s.win) CopyToClipboard	
			if ((GetKeyState(0) & 2^2) || (V_flag == 2 && V_value))								// shift key saves to clipboard
				PutScrapText Style
				PopupMenu GrStyle ,win=$(s.win) ,popMatch="From Clipboard"
			else
				Style = ReplaceString("\r", Style, ";")
				SetWindow $(s.win), userdata(CopyStyle)=Style									// save into panel's user data
				SetWindow $(s.win), userdata(CopyStyleName)=gName
				PopupMenu GrStyle ,win=$(s.win), popMatch="CStyle*"
			endif
		break
	EndSwitch
//	FetchLatestGraphSizeValues()
	return 0
End
//#########--**--        ------------------------------------------------          --**--#########
Function Gsize_VarControl(s) : SetVariableControl		//   GLStepsize = 2
	struct WMSetVariableAction &s
	if (s.eventCode == 1 || s.eventCode == 2)
		ExecuteVarChange(s.ctrlName, s.dval, 2)
	elseif(s.eventCode == 4)
		ExecuteVarChange(s.ctrlName, s.dval, 4)
	elseif(s.eventCode == 5)
		ExecuteVarChange(s.ctrlName, s.dval, 5)
	endif
	return 0
End
//#########--**--        ------------------------------------------------          --**--#########
static Function ExecuteVarChange(ctrlName, val, increaseExpansion)
	String ctrlName
	Variable val
	variable increaseExpansion	
	String gName = getTopGraph()
	String pName = "QGraphSizePanel"
	if (!strlen(gName))
		return 0
	endif

	ControlInfo/W=$pName SizeUnit
	Variable modifier = 1//V_Value == 1 ? 1 : (V_Value == 2 ? 72 : 72/2.54)	
// in points, inches or cm	//	only for points
	ControlInfo/W=$pName KeepAutoMode
	Variable Auto = V_Value													
// reset to Auto scale mode after size change
	ControlInfo/W=$pName cPrint
	Variable printcmd = V_flag == 2 ? V_Value :0
	
	if ((GetKeyState(0) & 2^0) != 0)	// press ctrl
		modifier *= 8
	endif
	variable Vstep = GLStepsize
	
	NVAR/Z unit = root:$ksGraphSizeUnitSave				// load saved settings
	if (NVAR_Exists(unit))
		PopupMenu SizeUnit ,mode=unit // 0 for point
	
		String CtrlList = RemoveFromList("VMagnification;VGraphFont;",ControlNameList(pName,";","V*"))
		Variable div  = unit == 1 ? 1 : (unit == 2 ? 72 : 72/2.54)	// in points, inches or cm, prefer the point
		Vstep = unit == 1 ? GLStepsize : (unit == 2 ? 0.014 : 0.036)
		//ModifyControlList CtrlList ,limits={0,8000/div,step}		// official max size is 8000 points
	endif
//	print Vstep
//	val += Vstep/10  * modifier
	if (increaseExpansion==4)
		val += Vstep  * modifier
	elseif(increaseExpansion==5)
		val -= Vstep  * modifier
	endif
//	print increaseExpansion, val
	val = val<0.05 ? 1 : val
	
	String cmd = ""
	StrSwitch(ctrlName)
		case "VLeftMargin":
			ModifyGraph/W=$gName margin(left) = (val)
			cmd = "margin(left)=" + num2str(round(val))
		break
		case "VBottomMargin":
			ModifyGraph/W=$gName margin(bottom) = (val)
			cmd = "margin(bottom)=" + num2str(round(val))
		break
		case "VRightMargin":
			ModifyGraph/W=$gName margin(right) = (val)
			cmd = "margin(right)=" + num2str(round(val))
		break
		case "VTopMargin":
			ModifyGraph/W=$gName margin(top) = (val)
			cmd = "margin(top)=" + num2str(round(val))
		break
		case "VGraphHeight":
			ControlInfo/W=$pName VTopMargin
			Variable mTop = V_Value
			ControlInfo/W=$pName VBottomMargin
			Variable mBot = V_Value
			Variable pHeight = val-mTop-mBot
			if (val == 0)
				ModifyGraph/W=$gName margin(top) = 0, margin(bottom) = 0,  height = 0
				cmd = "margin(top)=0, margin(bottom)=0,  height=0"
			elseif (pHeight > 0)
				ModifyGraph/W=$gName height = (pHeight)
				cmd = "height=" + num2str(round(pHeight))
			endif
		break
		case "VGraphWidth":
			ControlInfo/W=$pName VLeftMargin
			Variable mLeft = V_Value
			ControlInfo/W=$pName VRightMargin
			Variable mRight = V_Value
			Variable pWidth = val - mLeft - mRight
			if (val == 0)
				ModifyGraph/W=$gName margin(left) = 0, margin(right) = 0,  width = 0
				cmd = "margin(left)=0, margin(right)=0,  width=0"
			elseif (pWidth > 0)
				ModifyGraph/W=$gName width = (pWidth)
				cmd = "width=" + num2str(round(pWidth))
			endif
		break
		case "VPlotHeight":
			ModifyGraph/W=$gName height = (val)
			cmd = "height=" + num2str(round(val))
		break
		case "VPlotWidth":
			ModifyGraph/W=$gName width = val
			cmd = "width=" + num2str(round(val))
		break
		case "VMagnification":
			Variable Mag = val == 1 ? 0 : val	// reset to none
//			ModifyGraph/W=$gName expand = Mag
			ModifyGraph expand = Mag
			cmd = "expand=" + num2str(Mag)
		break
		case "VGraphFont":
			if ((GetKeyState(0) & 2^2) != 0)	// shift pressed
				ModifyGraph/W=$gName fSize = val-1
				cmd = "fSize=" + num2str(val-1)
			else
				ModifyGraph/W=$gName gfSize = val
				cmd = "gfSize=" + num2str(val)
			endif
		break
		case "QGraphThick":
			ModifyGraph/W=$gName axThick=val,axThick=val,btThick=val
			cmd = "axThick=" + num2str(val) + ",btThick=" + num2str(val)
			break
		case "QGraphbtLen":
			ModifyGraph/W=$gName  btLen=val
			cmd = "btLen=" + num2str(val)
			break
	EndSwitch
//
	if (printcmd)
		print "•ModifyGraph "+cmd
	endif
	
	if (Auto)
		DoUpdate/W=$gName
		if (StringMatch(ctrlName,"*Height"))
			ModifyGraph/W=$gName height = 0
		elseif (StringMatch(ctrlName,"*Width"))
			ModifyGraph/W=$gName width = 0
		endif
	endif
	FetchLatestGraphSizeValues()
	return 0
end
//#########--**--        ------------------------------------------------          --**--#########
Function Gaxis_VarControl(s) : SetVariableControl		//   GLStepsize = 2
	struct WMSetVariableAction &s
	if (s.eventCode == 1 || s.eventCode == 2)
		ExecuteaxVarChange(s.ctrlName, s.dval, 2)
	elseif(s.eventCode == 4)
		ExecuteaxVarChange(s.ctrlName, s.dval, 4)
	elseif(s.eventCode == 5)
		ExecuteaxVarChange(s.ctrlName, s.dval, 5)
	endif
	return 0
End
//#########--**--        ------------------------------------------------          --**--#########
static Function ExecuteaxVarChange(ctrlName, val, increaseExpansion)
	String ctrlName
	Variable val
	variable increaseExpansion	
	String gName = getTopGraph()
	String pName = "QGraphSizePanel"
	if (!strlen(gName))
		return 0
	endif

	ControlInfo/W=$pName SizeUnit
	Variable modifier = V_Value == 1 ? 1 : (V_Value == 2 ? 72 : 72/2.54)	
// in points, inches or cm
	ControlInfo/W=$pName KeepAutoMode
	Variable Auto = V_Value													
// reset to Auto scale mode after size change
	ControlInfo/W=$pName cPrint
	Variable printcmd = V_flag == 2 ? V_Value :0
	
	if ((GetKeyState(0) & 2^0) != 0)	// press ctrl
		modifier *= 6
	endif
	
	if (increaseExpansion==4)
		val += GLStepsize/2  * modifier
	elseif(increaseExpansion==5)
		val -= GLStepsize/2  * modifier
	endif
	
	String cmd = ""
	StrSwitch(ctrlName)
		case "tlAxis_left":
			val = abs(val)>49 ? (-1)^(increaseExpansion)*100 : val
			ModifyGraph/W=$gName tlOffset(left) = val
			cmd = "tlOffset(left)=" + num2str(val)
		break
		case "tlAxis_bottom":
			val = abs(val)>49 ? (-1)^(increaseExpansion)*100 : val
			ModifyGraph/W=$gName tlOffset(bottom) = val
			cmd = "tlOffset(bottom)=" + num2str(val)
		break
		case "tlAxis_right":
			val = abs(val)>49 ? (-1)^(increaseExpansion)*100 : val
			ModifyGraph/W=$gName tlOffset(right) = val
			cmd = "tlOffset(right)=" + num2str(val)
		break
		case "tlAxis_top":
			val = abs(val)>49 ? (-1)^(increaseExpansion)*100 : val
			ModifyGraph/W=$gName tlOffset(top) = val
			cmd = "tlOffset(top)=" + num2str(val)
		break
		case "alAxis_left":
			val = abs(val)>449 ? (-1)^(increaseExpansion)*450 : val
			ModifyGraph/W=$gName lblPosMode(left)=1, lblMargin(left) = val
			cmd = "lblMargin(left)=" + num2str(val)
		break
		case "alAxis_bottom":
			val = abs(val)>449 ? (-1)^(increaseExpansion)*450 : val
			ModifyGraph/W=$gName lblPosMode(bottom)=1, lblMargin(bottom) = val
			cmd = "lblMargin(bottom)=" + num2str(val)
		break
		case "alAxis_right":
			val = abs(val)>449 ? (-1)^(increaseExpansion)*450 : val
			ModifyGraph/W=$gName lblPosMode(right)=1, lblMargin(right) = val
			cmd = "lblMargin(right)=" + num2str(val)
		break
		case "alAxis_top":
			val = abs(val)>449 ? (-1)^(increaseExpansion)*450 : val
			ModifyGraph/W=$gName lblPosMode(top)=1, lblMargin(top) = val
			cmd = "lblMargin(top)=" + num2str(val)
		break
	EndSwitch
//
	if (printcmd)
		print "•ModifyGraph "+cmd
	endif
	
	FetchLatestGraphSizeValues()
	return 0
end
//#########--**--        ------------------------------------------------          --**--#########
Function Gsize_PresetPopup(s) : PopupMenuControl
	STRUCT WMPopupAction &s
	if (s.eventCode == 2)
		StrSwitch(s.ctrlName)
			case "AspectSelect":
			break
			case "FormatSelect":
			break
			case "SizeUnit":
				String CtrlList = RemoveFromList("VMagnification;VGraphFont;",ControlNameList(s.win,";","V*"))
				Variable div  = s.popNum == 1 ? 1 : (s.popNum == 2 ? 72 : 72/2.54)		// in points, inches or cm
				Variable step = s.popNum == 1 ? 1 : (s.popNum == 2 ? 0.014 : 0.036)
//				ModifyControlList CtrlList ,win=$(s.win) ,limits={0,8000/div,step*2}	// official max size is 8000 points

				ModifyControlList CtrlList ,win=$(s.win) ,limits={0,8000/div,0}	// official max size is 8000 points
				Variable/G root:$ksGraphSizeUnitSave = s.popNum							// save settings into global variable
				FetchLatestGraphSizeValues()
			break
		EndSwitch
	endif
	return 0
End
//#########--**--        ------------------------------------------------          --**--#########
Function FetchLatestGraphSizeValues()
//	Multiple graph layers lead to numerical confusion
	String gName = getTopGraph(), gRec = ""
	String pName = "QGraphSizePanel"
	String topGraph = WinName(0,1)
	if (!strlen(gName))
		DoWindow /T $pName, "GS: No Graph"
		return 0
	endif
	
	DoUpdate/W=$gName
	GetWindow/Z $gName gsize							// values from GetWindow (sometimes off by a fraction?)
	//print V_left, V_right, V_top, V_bottom		// debug
  	Variable gLeft	 = V_left
  	Variable gRight	 = V_right
  	Variable gTop	 = V_top
	Variable gBottom = V_bottom
  	Variable gWidth	 = V_right - V_left	
  	Variable gHeight = V_bottom - V_top	
	GetWindow/Z $gName psize
//print V_left, V_right, V_top, V_bottom		// debug
	Variable mLeft	 = round(V_left - gLeft)
	Variable mTop	 = round(V_top - gTop)
	Variable mRight	 = round(gRight - V_right)
	Variable mBottom = round(gBottom - V_bottom)
	Variable pWidth	 = round(V_right - V_left)
	Variable pHeight = round(V_bottom - V_top)
			gHeight	 = round(gHeight)
			gWidth	 = round(gWidth)
	variable gThick
	variable gbtLen
//#########--**--        ------------------------------------------------          --**--#########
	gRec = WinRecreation(gName, 0)
	Variable pos1 = 0
    Variable pos2 = 0

	if(GrepString(gName,"#") == 0)
		pos1 = StrSearch(gRec, "/HOST=#", 0)
        pos2 = StrSearch(gRec, ")", pos1)
		if(pos1>5)   // for the graph don't clude Subwindow
		gRec = gRec[0,pos1-1]
		endif
//        print  pos1, pos2		// for debug
	endif
//  ensure the prameters from the first host graph //	print gRec //	for debug
	variable HahMarkNum = itemsInList(gName, "#") - 1
	variable SlashHostNum = itemsInList(gRec, "/HOST=#") - 1
//	print gName, HahMarkNum, SlashHostNum			// for debug
	if(HahMarkNum && SlashHostNum>1)
		pos1 = StrSearch(gRec, "/HOST=#", 0)
        pos2 = StrSearch(gRec, "/HOST=#", pos1 + 10) 	// cross over the first "/HOST=#" to 2nd
//      print  pos1, pos2							// for debug
        gRec = gRec[pos1,pos2 - 1]
	endif
//	print gRec		// for debug
	gRec = GrepList(gRec, "^\t(ModifyGraph)", 0 , "\r")					
// if available, replace with values from recreation macro (these are exact)
	gRec = GrepList(gRec, "(?i)(swapXY|standoff|height|width|margin|gfsize|axThick|btLen)", 0, "\r")					
//	print gRec		//	extract only relevant keys   // for debug 
	gRec = ReplaceString("\tModifyGraph ", gRec, "")
	gRec = ReplaceString("\r", gRec, ",")
//	print gRec			// for debug
	Variable gSwap = str2num(StringByKey("swapXY", gRec, "=", ","))				// swap axes parameter
	Variable gMagn = abs(str2num(StringByKey("expand", gRec, "=", ",")))		// magnification parameter
	gSwap = numtype(gSwap) == 0 ? gSwap : 0
	gMagn = numtype(gMagn) == 0 ? gMagn : 1
	Variable Rec_mLeft	 = gSwap ? str2num(StringByKey("margin(bottom)", gRec, "=", ",")): str2num(StringByKey("margin(left)", gRec, "=", ","))
	Variable Rec_mTop	 = gSwap ? str2num(StringByKey("margin(right)", gRec, "=", ",")) : str2num(StringByKey("margin(top)", gRec, "=", ","))
	Variable Rec_mRight	 = gSwap ? str2num(StringByKey("margin(top)", gRec, "=", ","))	 : str2num(StringByKey("margin(right)", gRec, "=", ","))
	Variable Rec_mBottom = gSwap ? str2num(StringByKey("margin(left)", gRec, "=", ","))	 : str2num(StringByKey("margin(bottom)", gRec, "=", ","))
	Variable Rec_pWidth	 = gSwap ? str2num(StringByKey("height", gRec, "=", ","))		 : str2num(StringByKey("width", gRec, "=", ","))
	Variable Rec_pHeight = gSwap ? str2num(StringByKey("width", gRec, "=", ","))		 : str2num(StringByKey("height", gRec, "=", ","))
	Variable Rec_gHeight = Rec_pHeight + Rec_mBottom + Rec_mTop
	Variable Rec_gWidth	 = Rec_pWidth  + Rec_mRight  + Rec_mLeft
	
	variable Rec_gThick	 = str2num(StringByKey("axThick", gRec, "=", ","))
	variable Rec_btLen	 = str2num(StringByKey("btLen", gRec, "=", ","))
	Variable Rec_gFont	 = str2num(StringByKey("gfSize", gRec, "=", ","))

	Variable setstandoff = str2num(StringByKey("standoff", gRec, "=", ","))
	setstandoff	= numtype(setstandoff) == 0 ? setstandoff : 1

	Variable gFont = numtype(Rec_gFont) == 0 ? Rec_gFont : 10
//		print setstandoff	,setSwap	//debug
	if(numtype(Rec_gThick) == 2)
		Rec_gThick = 1.1
	Endif
//
	if(numtype(Rec_btLen) == 2)
		Rec_btLen = 1.1
	Endif

#if IgorVersion() >= 7
//	GetWindow/Z $gName expand						// fetch magnification in newer Igor versions
	Getwindow/Z $topGraph expand
	gMagn = V_Value == 0 ? 1 : V_Value
#endif
	// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	mLeft	= numtype(Rec_mLeft) 	== 0 ? Rec_mLeft : mLeft				// if the recreation values are valid then use these
	mBottom	= numtype(Rec_mBottom) 	== 0 ? Rec_mBottom : mBottom
	mRight	= numtype(Rec_mRight) 	== 0 ? Rec_mRight : mRight
	mTop	= numtype(Rec_mTop) 	== 0 ? Rec_mTop : mTop
	pWidth	= numtype(Rec_pWidth) 	== 0 ? Rec_pWidth : pWidth
	pHeight	= numtype(Rec_pHeight) 	== 0 ? Rec_pHeight : pHeight
	gHeight	= numtype(Rec_gHeight) 	== 0 ? Rec_gHeight : pHeight + mTop + mBottom
	gWidth	= numtype(Rec_gWidth) 	== 0 ? Rec_gWidth : pWidth + mLeft + mRight
	gThick  = Rec_gThick
	gbtLen  = Rec_btLen
//	gFont   = Rec_gFont

	ControlInfo/W=$pName SizeUnit
	Variable modifier = V_Value == 1 ? 1 : (V_Value == 2 ? 72 : 72/2.54)	// in points, inches or cm
	if (modifier != 1)
		mLeft	= round((mLeft	 /modifier)*1000)/1000
		mBottom	= round((mBottom /modifier)*1000)/1000
		mRight	= round((mRight	 /modifier)*1000)/1000
		mTop	= round((mTop	 /modifier)*1000)/1000
		gHeight	= round((gHeight /modifier)*1000)/1000
		pWidth	= round((pWidth	 /modifier)*1000)/1000
		gWidth	= round((gWidth	 /modifier)*1000)/1000
		pHeight	= round((pHeight /modifier)*1000)/1000
		gThick	= round((gThick  /modifier)*1000)/1000
		gbtLen	= round((gbtLen  /modifier)*1000)/1000
//		gFont	= round((gFont   /modifier)*1000)/1000
	endif
// +++++++++++++++++++++++++++++++ apply info to panel controls ++++++++++++++++++++++++++++++
	String undoGName = GetUserData(pName, "", "LastgName")					// check for existence of a undo style for the current graph
	DoWindow /T $pName, "GS: " + gName
	CheckBox SwapAxes			,win=$pName	,value=gSwap
	CheckBox standoffAxes		,win=$pName	,value=setstandoff
	SetVariable VLeftMargin		,win=$pName	,value=_NUM:mLeft	,fstyle=(numtype(Rec_mLeft)==0)
	SetVariable VBottomMargin	,win=$pName	,value=_NUM:mBottom	,fstyle=(numtype(Rec_mBottom)==0)
	SetVariable VRightMargin	,win=$pName	,value=_NUM:mRight	,fstyle=(numtype(Rec_mRight)==0)
	SetVariable VTopMargin		,win=$pName	,value=_NUM:mTop	,fstyle=(numtype(Rec_mTop)==0)
	SetVariable VGraphHeight	,win=$pName	,value=_NUM:gHeight	,fstyle=(numtype(Rec_gHeight)==0)
	SetVariable VPlotWidth		,win=$pName	,value=_NUM:pWidth	,fstyle=(numtype(Rec_pWidth)==0)
	SetVariable VGraphWidth		,win=$pName	,value=_NUM:gWidth	,fstyle=(numtype(Rec_gWidth)==0)
	SetVariable VPlotHeight		,win=$pName	,value=_NUM:pHeight	,fstyle=(numtype(Rec_pHeight)==0)
	SetVariable VGraphFont		,win=$pName	,value=_NUM:gFont	,fstyle=(numtype(Rec_gFont)==0)
	SetVariable VMagnification	,win=$pName	,value=_NUM:gMagn
	SetVariable QGraphThick		,win=$pName	,value=_NUM:gThick
	SetVariable QGraphbtLen		,win=$pName	,value=_NUM:gbtLen
//	PopupMenu AspectSelect		,win=$pName	,popMatch=StringFromList(sel,PopList)
	Button RevertButton			,win=$pName	,disable=2*(!StringMatch(gName,undoGName))			
	// disable button if undo backup does not match to current graph
	
	Variable i
	String axes = "left;bottom;right;top;"
	for (i = 0; i < ItemsInList(axes); i += 1)								// set axis checkboxes
		Variable isOn = 0, tickOffset = 0, lblOffset = 0
		String currAxis = StringFromList(i,axes)
		gRec = AxisInfo(gName,currAxis)
		if (strlen(gRec))
			isOn = (str2num(StringByKey("tick(x)",gRec,"=",";"))!=3 && str2num(StringByKey("noLabel(x)",gRec,"=",";"))!= 2)		// inactive if both tick(x)=3 and noLabel(x)=2
			tickOffset = str2num(StringByKey("tlOffset(x)",gRec,"=",";"))
			lblOffset  = str2num(StringByKey("lblMargin(x)",gRec,"=",";"))
		endif
		CheckBox $("cAxis_"+currAxis) ,win=$pName ,value=isOn ,disable=2*(strlen(gRec)==0)
		ControlInfo/W=$pName $("tlAxis_"+currAxis)
		if (abs(V_Flag) == 5)
			SetVariable $("tlAxis_"+currAxis) ,win=$pName ,value=_NUM:tickOffset ,disable=2*(strlen(gRec)==0)
		endif
		ControlInfo/W=$pName $("alAxis_"+currAxis)
		if (abs(V_Flag) == 5)
			SetVariable $("alAxis_"+currAxis) ,win=$pName ,value=_NUM:lblOffset ,disable=2*(strlen(gRec)==0)
		endif
	endfor
	return 0
End
//#########--**--        ------------------------------------------------          --**--#########
Function FetchLatestSubWinValues()
	String SubName = getTopGraph(), gRec = ""
	String gName = WinName(0, 1)
	String pName = Winname(0, 64)
	variable wid_len = strlen(SubName)
	wid_len = wid_len < 47 ? 47:wid_len
		
//	print ScreenResolution/PanelResolution(pName)
	string ttlabel = "set position for:"// + SubName
//	
	DoUpdate/W=$SubName
	GetWindow/Z $gName gsize	// HOST graph
	Variable gLeft	= V_left
  	Variable gRight	= V_right
  	Variable gTop	= V_top
	Variable gBottom= V_bottom
	Variable gWidth	= V_right-V_left
  	Variable gHeight= V_bottom-V_top
//	print gLeft, gRight, gTop, gBottom, gWidth, gHeight
	
	GetWindow/Z $SubName wsizeRM	// /subwindow	
// 	values from GetWindow/Z (sometimes off by a fraction?)
//	print SubName, V_left, V_right, V_top, V_bottom		// debug
  	Variable subLeft	= V_left
  	Variable subRight	= V_right
  	Variable subTop		= 	V_top
	Variable subBottom	= V_bottom
  	if(max(max(subleft, subright), max(subtop, subbottom))<=1)  // for igor6
  		subLeft		= V_left*gWidth
  		subRight	= V_right*gRight
  		subTop		= V_top*gHeight
		subBottom	= V_bottom*gBottom
	endif
//	print subLeft, subRight, subTop, subBottom	//  need to be checked in future
//#########--**--        ------------          --**--#########
	SetVariable SubWinX_posi	,win=$pName, value	=_NUM:SubLeft//, fstyle=(numtype(Rec_mLeft)==0)
	SetVariable SubWinY_posi	,win=$pName, value	=_NUM:SubTop//, fstyle=(numtype(Rec_mLeft)==0)
// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// resize the winsize
	variable P_ritio = 1
#if IgorVersion() > 7
	P_ritio = ScreenResolution/PanelResolution(pName)	
#endif
	if(stringmatch(pName, "SubWinTB"))
		GetWindow/Z $pName wsize
		MoveWindow/W=$pName V_left, V_top, V_left+(288 + 4.55*(wid_len-47))/P_ritio, v_bottom
		TitleBox tb1,title=ttlabel
		SetVariable Subgname ,win=$pName, size = {289 + 5.25*(wid_len - 47), 18}, value= _STR:SubName
	endif
	return 0
End
//#########--**--        ------------------------------------------------          --**--#########
static Function/S KBActiveGraph()
	// Active graphs can be embedded in panels and layouts
	String windows = WinList("*", ";", "")
	String topwindow = StringFromList(0, windows)
	
	String topWin = WinName(0,1+4+64)		// Graphs+Layouts+Panels, usually KBColorizePanel
	String nextWin = WinName(1,1+4+64)		// Graphs+Layouts+Panels
	String graphName = WinName(0,1+4+64)
	if( CmpStr(topWin,"QGraphSizePanel") == 0 )
		topWin= nextWin
	endif
	if( strlen(topWin) )
		GetWindow/Z $topWin activeSW
		if( WinType(S_Value) == 1 && WinType(S_value) == 3 && WinType(S_value) == 7)
			graphName= S_value
		endif
	endif
	return graphName
End
//#########--**--        ------------------------------------------------          --**--#########
static Function/S KBActiveGraphHost()
	String graphName=KBActiveGraph()
	String hostName= StringFromList(0, graphName, "#")
	return hostName
End
//
function addVersionTag()
	SetDrawLayer UserBack
	ControlInfo goWebsiteButton
//	V_left, V_top, V_Height
	string Vband = "V" + num2str(GTversion)

//	SetDrawEnv textrgb= (65535,16385,16385),fsize= 12,fstyle=1
//	DrawText V_left+52, V_top+V_Height+16, Vband
	Button releaseButton	,pos={V_left+56, V_top+V_Height+3},size={32,15}	,title=Vband,fsize=10,proc=GSAlityControl,fColor=(65535,60076,49151)
//	print V_left,V_top+V_Height		// for debug
end
//-------------------------------- functions for user code ---------------------------------------
static Function TraceTool_FetchXShift(input, unit)												// extract predetermined X offset shift values from data
	Wave input
	String &unit																				// optional unit string
	Variable xShift = NaN																		// the shift value which will be preset in the panel
// ++++++++++++++++++++++ get the photon energy as shift value +++++++++++++++++++++++++++++++
	Variable neg = 1
	String notes = note(input)
	String energy = StringByKey("Xray energy", notes, "=","\r")									// find the photon energy
	if (!strlen(energy))
		energy = StringByKey("photon energy ", notes, "=","\r")									// try a different key
	endif
	if (!strlen(energy))
		energy = StringByKey("Excitation Energy", notes, "=","\r")								// try yet a different key
		neg = -1																				// this data requires flipping
	endif
	unit = "eV"
	xShift = str2num(energy)*neg
	if (xShift == 0)
		xShift = NaN
	endif
	// 
	return xShift 																				// return NaN for no change and return negative values for flipping the trace
End
//
static Function getAllTraceOffsets(gName, trace, xOff, yOff, xScale, yScale)
	String gName, trace
	Variable &xOff, &yOff, &xScale, &yScale
	String info = TraceInfo(gName,trace,0)
	sscanf StringByKey("offset(x)", info, "="), "{%f,%f}", xOff, yOff
	sscanf StringByKey("muloffset(x)", info, "="), "{%f,%f}", xScale, yScale
	yScale = yScale == 0? 1 : yScale
	xScale = xScale == 0? 1 : xScale
	return 0
End
//
static Function TraceTool_FetchYShift(input,unit)												// extract predetermined Y offset shift values
	Wave input
	String &unit
	return NaN	 																				// return NaN for no change and return negative values for flipping the trace
End
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
static Function/S RemoveFromListWC(listStr, zapListStr)											// returns listStr, purged of any items that match an item in ZapListStr.
	String listStr, zapListStr
	String removeStr=""
	Variable i
	for(i = 0; i < ItemsInList(zapListStr); i += 1)
		removeStr += ListMatch(listStr, StringFromList(i, zapListStr))							// Wildcards okay! Case insensitive.
	endfor
	return RemoveFromList(removeStr, listStr, ";", 0)
End
//++++++++++++++++++++++++++++++ help function to get a trace list ++++++++++++++++++++++++++++++
static Function FetchTraces(win,traces,getAll)
	String win, &traces
	Variable getAll
	
	Variable noHidden = 0, omit = 0
	String filter = ""
	if (WinType("TraceOffsetPanel") && !getAll)													// read settings from panel if open
		ControlInfo/W=TraceOffsetPanel#MultiTab cHiddenTraces
		if (V_flag)
			noHidden = !V_Value
		endif
		ControlInfo/W=TraceOffsetPanel#MultiTab vTraceFilter
		if (V_flag)
			filter = S_Value
		endif
		ControlInfo/W=TraceOffsetPanel#MultiTab cOmitFilter
		if (V_flag)
			omit = V_Value
		endif
	endif
	
	traces = TraceNameList(win,";",1+4*noHidden)
	Variable i, items = ItemsInList(filter)
	if (strlen(filter))																			// filter each list item
		if (omit)
			for (i = 0; i < items; i += 1)
				traces = RemoveFromList(ListMatch(traces,StringFromList(i,filter)),traces)
			endfor
		else
			String tempList = ""
			for (i = 0; i < items; i += 1)
				tempList += ListMatch(traces,StringFromList(i,filter))
			endfor
			traces = tempList
		endif
	endif
	
	items = ItemsInList(traces)
	String xAxis, remItem = ""
	for (i = 0; i < items; i += 1)
		xAxis = StringByKey("XAXIS",  TraceInfo(win,StringFromList(items-1 - i,traces),0))
		//if (!(StringMatch(xAxis,"bottom") || StringMatch(xAxis,"top")))						// remove vertical traces
		if (StringMatch(xAxis,"Profilebottom") || StringMatch(xAxis,"Profileleft"))				// remove profile trace
			remItem += StringFromList(items-1 - i,traces)+";"
		endif
	endfor
	traces = RemoveFromList(remItem,traces)
	traces = RemoveFromListWC(traces, ksTraceIgnoreList)
	return ItemsInList(traces)
End
//----------------------------------------------------------------------------------------------
static Function/S Gsize_cleanupMacro(str)
	String str
	str = RemoveFromList(ListMatch(str,"*Proc*","\r"), str, "\r")								// remove "proc" line
	str = RemoveFromList(ListMatch(str,"*PauseUpdate*","\r"), str, "\r")						// remove "pauseupdate" line
	str = RemoveFromList(ListMatch(str,"*EndMacro*","\r"), str, "\r")							// remove "endmacro" line
	str = ReplaceString("\t", str, "")
	str = GrepList(str, "^(DefineGuide|ControlBar|SetWindow|Cursor|ListBox|CheckBox|PopupMenu|ValDisplay|SetVariable|Button|TitleBox|Slider|GroupBox|NewPanel|ModifyPanel|RenameWindow|SetActiveSubwindow|ShowTools)", 1, "\r") // remove control items
	str = GrepList(str, "^(ModifyGraph/Z rgb|ModifyGraph/Z muloffset|ModifyGraph/Z offset|ShowInfo)", 1, "\r")
	return str
End
//------------------------------------------------------------------------------------------------
//	attaches a quick-scaling menu to the top graph
//	version 4 -  2022/03
//------------------------------------------------------------------------------------------------
Function QAttachQuickScalePanel()
	String win=getTopMainGraph()
	if (strlen(win) == 0)
		return 0
	endif
	GetWindow/Z $win hook(MainWindow)
	if (StringMatch(S_Value, "QuickScale_GraphHook"))
		return 0
	endif
	SetWindow $win hook(MainWindow) = QuickScale_GraphHook, hookevents = 4
	ShowInfo
	hideInfo
	
	//++++++++++++++++++++++++++++++ build the panel ++++++++++++++++++++++++++++++++	
	String pPath = win + "#QkScalePanel"
	String pName = "QkScalePanel"
//
	if (WinType(pName))
		DoWindow/K/Z $pName
//		AutoPositionWindow/M=0/R=$topGraphHost $pName
//		return 0
	endif
	
	NewPanel/HOST=$win/N=QkScalePanel/EXT=0/W=(0,0,130,452) as "Norm & Scale"
	
	TitleBox tCursor		,pos={10,10}	,size={90,23}	,title="No Cursor"	,frame=0 	,fstyle=1	,userdata="none"
	Button bAddCursor		,pos={70,8}		,size={20,20}	,title="+"		,help={"Adds a new cursor to the graph."}
	Button bdelCursor		,pos={95,8}		,size={20,20}	,title="-"		,help={"Adds a new cursor to the graph."}

	Button bTracePrev		,pos={4,33}		,size={25,20}	,title="<<"		,help={"Set cursor to previous trace in list."}
	Button bTraceNext		,pos={32,33}	,size={25,20}	,title=">>"		,help={"Set cursor to next trace in list."}
	
	Button bFindMin			,pos={61,33}	,size={30,20}	,title="Min"	,help={"Find the minimum data value."}
	Button bFindMax			,pos={94,33}	,size={31,20}	,title="Max"	,help={"Find the maximum data value."}

	TitleBox tFindPos		,pos={8,55}	,size={90,23}	,title="Cursor at:"	,frame=0
	
	TitleBox tTraceName		,pos={8,72}	,size={90,23}	,title="--trace name",frame=0, labelBack=(65535,60076,49151)

	DrawLine 8, 95, 122 ,95		//  first line
	variable x_s = 13, y_s = 0
	
	TitleBox tNormalize		,pos={10,118 - x_s}	,size={90,23}	,title="Normalize to:"		,frame=0
	SetVariable vNormalize	,pos={8,138 - x_s}	,size={90,23}	,title=""					,help={"Normalizes the spectrum to this value at cursor position."}
	Button bNormBack		,pos={8,163 - x_s}	,size={90,20}	,title="Revert Norm."		,help={"Undoes the previous normalization."}
	DrawLine 8, 192 - x_s, 122 ,192 - x_s
	CheckBox cImageYShift	,pos={52,200 - x_s}	,size={35,23}	,title="do Y:"				,fColor=(0,0,65280)
	TitleBox tShift			,pos={10,200 - x_s}	,size={90,23}	,title="X pos:"				,frame=0
	SetVariable vShift		,pos={8,220 - x_s}	,size={90,23}	,title=""					,help={"Offsets the selected axis so that the cursor will be at this value."}
	TitleBox tRelShift		,pos={10,245 - x_s}	,size={90,23}	,title="Relative X shift:"	,frame=0	
	SetVariable vRelShift	,pos={8,265 - x_s}	,size={90,23}	,title=""					,help={"Offsets the selected axis by this relative value."}
	
	DrawLine 8, 294 - x_s, 122 ,294 - x_s	//  second line
	
	TitleBox tPhoton		,pos={10,300 - x_s}	,size={90,23}	,title="Photon Energy"		,frame=0
	SetVariable vPhoton		,pos={8,320 - x_s}	,size={90,23}	,title=""					,help={"Set the photon energy."}
	Button bSwitch			,pos={8,345 - x_s}	,size={90,20}	,title="KE <> BE"			,help={"Switch between kinetic and binding energy using the set photon energy."}
	DrawLine 8, 374 - x_s, 98 ,374 - x_s
	TitleBox tArithmetic	,pos={10,380 - x_s}	,size={90,23}	,title="Arithmetic Op.:"	,frame=0
	SetVariable vArithmetic	,pos={8,400 - x_s}	,size={90,23}	,title=""					,help={"Multiply, divide, add, subtract a value by/to/from the data by this command just like in the command line."}
	CheckBox cImageOneCol	,pos={9,423 - x_s}	,size={90,23}	,title="One Column"			,help={"Applies arithmetic operation to the selected column only instead of the full image."}	,value=1
	//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	ModifyControlList ControlNameList(pPath,";","b*")		,proc=QuickRescale_ButtonExecute
	ModifyControlList ControlNameList(pPath,";","v*")		,proc=QuickRescale_VariableExecute
	SetVariable vShift		,value=_NUM:0	,limits={-inf,inf,1}	,format="%g"
	SetVariable vNormalize	,value=_NUM:0	,limits={-inf,inf,1}					,userdata(reset)="0"	,userdata(wavname)="none"
	SetVariable vRelShift	,value=_NUM:0	,limits={-inf,inf,1}	,format="%g"	,userdata(offset)="0"	,userdata(wavname)="none"
	SetVariable vPhoton		,value=_NUM:0	,limits={0,inf,0}		,format="%g"
	SetVariable vArithmetic	,value=_STR:""
	ModifyControlList ControlNameList(pPath,";","!bAddCursor") disable = 2						// disable everything for now (other than the add cursor button)
	CheckBox cImageYShift	,side=1			,disable=1		,proc=QuickRescale_CheckExecute	
	
	if (CmpStr(IgorInfo(2), "Macintosh") == 0)
		ModifyControlList ControlNameList(pPath,";","*")	,win=$pPath	,fsize=10
	endif
	
	SetWindow $(pPath) hook(SubWindow)=QuickScale_PanelHook										// set an additional hook to handle close events
	SetActiveSubwindow $win																		// restore focus to main window
	
	Variable i
	String csr = "", csrList = "A;B;C;D;E;F;G;H;I;J;"
	for (i = 0; i < ItemsInList(csrList); i += 1)												// see if a cursor is set already
		csr = StringFromList(i,csrList)
		if (strlen(CsrInfo($csr,win)))
			String trace = StringByKey("TNAME",CsrInfo($csr,win))
			if (strlen(ImageInfo(win,trace,0)))													// update the cursor (recalculates the control values)
				Cursor/I/P $csr, $trace, pcsr($csr,win), qcsr($csr,win)							// move cursor to image position
			else
				Cursor/P $csr, $trace, pcsr($csr,win)											// move cursor to trace position
			endif
			break
		endif
	endfor
	
	return 0
End
//################################################################################################
Function QuickScale_GraphHook(s)
	STRUCT WMWinHookStruct &s
	String pPath = s.WinName+"#QkScalePanel"
	
	Variable i, HookTakeover = 0
	Switch(s.eventCode)
		case 8:		// modified => if trace gets added or removed
		case 7:		// cursor moved
			if (WinType(pPath) != 7)															// something went wrong, since there is no panel => remove hook
				SetWindow $s.WinName hook(MainWindow)=$""
				return 0
			endif
			String csr = s.CursorName, trace = s.TraceName, csrList = "A;B;C;D;E;F;G;H;I;J;"
			if (!strLen(trace))																	// if the trace is not assigned, look for other cursors
				for (i = 0; i < ItemsInList(csrList); i += 1)
					csr = StringFromList(i,csrList)
					if (strlen(CsrInfo($csr,s.WinName)))
						trace = StringByKey("TNAME",CsrInfo($csr,s.WinName))
						break
					endif
				endfor
			endif
			
			if (!strLen(trace))																	// still not trace? => abort
				TitleBox tCursor ,win=$pPath ,title="No Cursor" ,userdata="none"
				ModifyControlList ControlNameList(pPath,";","!bAddCursor") ,win=$pPath ,disable = 2		// disable everything other than the add cursor button
				CheckBox cImageYShift ,win=$pPath	,disable=1
				return 0
			endif
			HookTakeover = 1
			
			Wave inwave  = CsrWaveRef($csr,s.WinName)
			Wave/Z xwave = CsrXWaveRef($csr,s.WinName)
			
			String wName = NameOfWave(inwave)
			String imgInfo = ImageInfo(s.WinName,s.TraceName,0)
			Variable isImage = strlen(imgInfo)

			ModifyControlList ControlNameList(pPath,";","*")		,win=$pPath ,disable = 0			// re-enable everything
			ModifyControlList ControlNameList(pPath,";","bTrace*")	,win=$pPath ,disable = 2*isImage	// disable trace controls for an image
			
			String hUnit, wUnit = WaveUnits(inwave,0), wOffsets
			Variable hv = abs(TraceTool_FetchXShift(inwave, hUnit));	hv = numtype(hv) ? 0 : hv
			Variable xOff = DimOffset(inwave,0), yOff = DimOffset(inwave,1), xDelta = DimDelta(inwave,0), yDelta = DimDelta(inwave,1)
			if (isImage)
				Wave/Z imgXW = $(StringByKey("XWAVEDF",imgInfo)+StringByKey("XWAVE",imgInfo))
				Wave/Z imgYW = $(StringByKey("YWAVEDF",imgInfo)+StringByKey("YWAVE",imgInfo))
				if (WaveExists(imgXW))
					xOff = imgXW[0]
					xDelta = (imgXW[DimSize(imgXW,0)-1] - imgXW[0])/(DimSize(imgXW,0)-1)
				endif
				if (WaveExists(imgYW))
					yOff = imgYW[0]
					yDelta = (imgYW[DimSize(imgYW,0)-1] - imgYW[0])/(DimSize(imgYW,0)-1)
				endif
			elseif(WaveExists(xwave))
				xOff = xwave[0]
				xDelta = (xwave[DimSize(xwave,0)-1] - xwave[0])/(DimSize(xwave,0)-1)
			endif
			sprintf wOffsets, "%f;%f;", xOff, yOff
			
			ControlInfo/W=$pPath cImageYShift
			Variable useY = V_Value && isImage
			Variable curPos = useY ? vcsr($csr, s.WinName) : hcsr($csr, s.WinName)
			Variable height = isImage ? zcsr($csr, s.WinName) : vcsr($csr, s.WinName)
			
			String offsetWave = GetUserData(pPath, "vRelShift",  "wavname")
			String renormWave = GetUserData(pPath, "vNormalize", "wavname")
			Variable startOff = str2num(StringFromList(useY,GetUserData(pPath, "vRelShift", "offset")))
			
			TitleBox tShift			,win=$pPath	,title=SelectString(useY,"X pos:","Y pos:")
			TitleBox tRelShift		,win=$pPath	,title=SelectString(useY,"Relative X shift:","Relative Y shift:")
			CheckBox cImageYShift 	,win=$pPath	,disable=!isImage
			CheckBox cImageOneCol	,win=$pPath	,disable=!(WaveDims(inwave)==2)*2
			TitleBox tCursor		,win=$pPath	,title = "Cursor "+csr	,userdata=csr									// the cursor position will be saved into the variable control
			TitleBox tTraceName		,win=$pPath	,title = wName	//,userdata=csr
			
			SetVariable vShift		,win=$pPath	,value=_NUM:curPos		,limits={-inf,inf,(useY ? yDelta : xDelta)} ,format="%g "+wUnit
			SetVariable vNormalize	,win=$pPath	,value=_NUM:height		,limits={-inf,inf,height/10}
			if(!StringMatch(wName,renormWave))																			// check if the current and the last waves are the same
				SetVariable vNormalize	,win=$pPath	,userdata(reset)="0" ,userdata(wavname)=wName						// if not, switch over to the new wave
			endif
			if(StringMatch(wName,offsetWave))																			// check if the current and the last waves are the same
				SetVariable vRelShift	,win=$pPath	,value=_NUM:(round(((useY ? yOff : xOff)-startOff)*10000)/10000)	// set control to the updated value
			else
				SetVariable vRelShift	,win=$pPath	,value=_NUM:0 ,limits={-inf,inf,(useY ? yDelta : xDelta)} ,userdata(wavname)=wName ,userdata(offset)=wOffsets ,format="%g "+wUnit
			endif
			if (hv != 0)
				SetVariable vPhoton		,win=$pPath	,value=_NUM:hv ,format="%g "+hUnit
			endif
		break
	EndSwitch
	return HookTakeover
End
//------------------------------------------------------------------------------------------------
Function QuickScale_PanelHook(s)
	STRUCT WMWinHookStruct &s
	if (s.eventCode == 17)	// kill
		String gName = StringFromList(0, s.WinName, "#")
		HideInfo/W=$gName
		SetWindow $gName hook(MainWindow)=$""													// remove hook from main window
	endif
	return 0
End
//------------------------------------------------------------------------------------------------
Function QuickRescale_ButtonExecute(s) : ButtonControl
	STRUCT WMButtonAction &s
	if (s.eventCode != 2)
		return 0
	endif
	
	String gName = StringFromList(0, s.win, "#")
	String csr = GetUserData(s.win, "tCursor", "")
	String traceList = "", trace = ""
	Variable Findx = 0, Findy = 0
	Variable items = FetchTraces(gName,traceList,0)
	
	if (CmpStr(csr,"none") != 0 && strlen(csr))
		Wave yw = CsrWaveRef($csr,gName)
		Wave/Z xw = CsrXWaveRef($csr,gName)
		trace = StringByKey("TNAME",CsrInfo($csr,gName))
		Findx = pcsr($csr,gName)
		Findy = qcsr($csr,gName)
	endif
	if (!strlen(trace) && CmpStr(s.ctrlName,"bAddCursor") != 0)
		s.ctrlName = ""
	endif
	
	Variable i, GoUp = 0, xOff = 0, yOff = 0, xScale = 0, yScale = 0
	StrSwitch(s.ctrlName)
		case "bFindMax":
			WaveStats/Q yw
			Findx = V_maxRowLoc
			Findy = V_maxColLoc
		break
		case "bFindMin":
			WaveStats/Q yw
			Findx = V_minRowLoc
			Findy = V_minColLoc
		break
		case "bSwitch":
			ControlInfo/W=$(s.win) vPhoton
			Variable start = DimOffset(yw,0)
			if (WaveExists(xw))
				start = xw[0]
			endif
			
			Variable hv = V_Value, skip = 0			
			if (numtype(hv) == 0 && hv > 0)
				#if (Exists("QkRescale_UserFunc") == 6)										// uses user code for photon energy handling
					skip = QuickRescale_UserFunc(yw, xw, hv)
				#endif
				if (skip)
					break
				endif
//------------------------------------------------------------------------------------------------
				String notes = GetUserData(s.win, "vRelShift", "offset")						// get the initial x offset
				hv = start < 0 ? hv : -hv														// decide the direction
				if ((start+hv)*start <= 0)
					if (WaveExists(xw))
						xw += hv
					else
						SetScale/P x start+hv, DimDelta(yw,0), WaveUnits(yw,0), yw
					endif
					sprintf notes, "%f;%s;",str2num(StringFromList(0,notes))+hv, StringFromList(1,notes)	// write new offset
					SetVariable vRelShift ,win=$(s.win) ,userdata(offset)=notes					// set new offset
				else
					Print "Photon energy is too small."
				endif
			else
				Print "Photon energy needs to be a positive number."
			endif
		break
		case "bNormBack":
			Variable oldMax = str2num(GetUserData(s.win, "vNormalize", "reset")), newMax = Wavemax(yw)
			if (oldMax != 0 && numtype(oldMax) == 0)
				yw *= oldMax/newMax																// normalize the wave
				SetVariable vNormalize ,win=$(s.win) ,userdata(reset)="0"
			endif
		break
		case "bAddCursor":
			String csrList = "A;B;C;D;E;F;G;H;I;J;"
			for (i = 0; i < ItemsInList(csrList); i += 1)										// find first unused cursor
				csr = StringFromList(i,csrList)
				if (!strlen(CsrInfo($csr,gName)))
					break
				endif
			endfor
			
			if (!items)																			// if there are no traces, then this must be an image
				trace = StringFromList(0,ImageNameList(gName, ";"))
				Wave yw = ImageNameToWaveRef(gName,trace)
			else
				trace = StringFromList(0,traceList)
				Wave yw = TraceNameToWaveRef(gName,trace)
				Wave/Z xw = XWaveRefFromTrace(gName,trace)										// xw is only needed for traces
			endif
			
			Findx = DimSize(yw,0)/2																// set a new cursor on the center of the first trace or image
			if (!items)
				Findy = DimSize(yw,1)/2
			else
				GetAxis/W=$gName/Q bottom
				if (!V_flag)
					getAllTraceOffsets(gName, trace, xOff, yOff, xScale, yScale)				// center of the current axis corrected for scaling and offset of the current trace
					if (WaveExists(xw))
						FindLevel/P/Q xw, (V_min+(V_max-V_min)/2 - xOff)/xScale
						Findx = (!v_flag && v_levelX > 0 && v_levelX < DimSize(xw,0)-1) ? v_levelX : round(DimSize(xw,0)/2)		// make sure to stay within range
					else
						Findx = x2pnt(yw,(V_min+(V_max-V_min)/2 - xOff)/xScale)
					endif
				endif
			endif
		break
		case "bdelCursor":
//			controlInfo tCursor
//			string csrT = S_Value
//			print csrT
//			
//			csr = csrT[strlen(csrT) - 1]
			Cursor/K/W=$gName  $csr
			return 0
		break
		case "bTraceNext":
			GoUp = 1
		case "bTracePrev":
			if (strlen(ImageInfo(gName,trace,0)))
				break
			endif
			getAllTraceOffsets(gName, trace, xOff, yOff, xScale, yScale)
			Findx = hcsr($csr, gName)*xScale + xOff												// correct for current trace's offsets	
			
			Variable curTrace = WhichListItem(trace, traceList)
			if (GoUp)
				if (curTrace < items-1)
					 trace = StringFromList(curTrace+1,traceList)
				endif
			else
				if (curTrace > 0)
					 trace = StringFromList(curTrace-1,traceList)
				endif
			endif
			Wave yw = TraceNameToWaveRef(gName, trace)
			Wave/Z xw = XWaveRefFromTrace(gName,trace)
			
			getAllTraceOffsets(gName, trace, xOff, yOff, xScale, yScale)						// correct for next trace's offsets
			if (WaveExists(xw))
				FindLevel/P/Q xw, (Findx - xOff)/xScale
				Findx = (!v_flag && v_levelX > 0 && v_levelX < DimSize(xw,0)-1) ? v_levelX : round(DimSize(xw,0)/2)			// make sure to stay within range
			else
				Findx = x2pnt(yw,(Findx - xOff)/xScale)
			endif
		break
	EndSwitch

	if (strlen(ImageInfo(gName,trace,0)))
		Cursor/P/I $csr, $trace, Findx, Findy													// move cursor to image position
	else
		Cursor/P $csr, $trace, Findx															// move cursor to trace position
	endif
	SetActiveSubwindow $gName																	// restore focus to main window
	return 0
End
//------------------------------------------------------------------------------------------
Function QuickRescale_VariableExecute(s) : SetVariableControl
	STRUCT WMSetVariableAction &s
	if (!(s.eventCode == 1 || s.eventCode == 2))
		return 0
	endif
	
	String win=getTopMainGraph()
	String varStr = s.sval
	String gName = StringFromList(0, s.win, "#")
	String csr = GetUserData(s.win, "tCursor", "")
	if (CmpStr(csr,"none") == 0 || !strlen(csr))
		return 0
	endif
	Wave yw = CsrWaveRef($csr, gName)
	Wave/Z xw = CsrXWaveRef($csr,gName)
	String trace = StringByKey("TNAME",CsrInfo($csr,gName))
	String imgInfo = ImageInfo(gName,trace,0)
	
	Wave yw = CsrWaveRef($csr,gName)
	Wave/Z xw = CsrXWaveRef($csr,gName)
	trace = StringByKey("TNAME",CsrInfo($csr,gName))
	Variable Findx = 0, Findy = 0
	
	Findx = pcsr($csr,gName)
	Findy = qcsr($csr,gName)
	
	ControlInfo/W=$(s.win) cImageYShift
	Variable useY = V_Value && !V_disable, modVal, iniVal
	
	if (strlen(imgInfo))																		// the xw is used for shifts
		if (useY)
			Wave/Z xw = $(StringByKey("YWAVEDF",imgInfo)+StringByKey("YWAVE",imgInfo))
		else
			Wave/Z xw = $(StringByKey("XWAVEDF",imgInfo)+StringByKey("XWAVE",imgInfo))
		endif
	endif
	
	StrSwitch(s.ctrlName)
		case "vNormalize":
			modVal = strlen(ImageInfo(gName,trace,0)) ? zcsr($csr,gName)/s.dval : vcsr($csr,gName)/s.dval	// get the 1D y-value or 2D z-value of the cursor
			iniVal = str2num(StringFromList(useY,GetUserData(s.win, "vNormalize", "reset")))
			if (modVal != 0 && numtype(modVal) == 0)
				if (iniVal == 0)
					SetVariable vNormalize ,win=$(s.win) ,userdata(reset)=num2str(Wavemax(yw))				// the original height will be saved into the variable control
				endif
				yw /= modVal
			endif
		break
		case "vShift":
			modVal = useY ? vcsr($csr,gName) : hcsr($csr,gName)
			if (WaveExists(xw))
				xw -= (modVal-s.dval)
				break
			endif
			if (useY)
//				SetScale/P y, DimOffset(yw,1)-(modVal-s.dval), DimDelta(yw,1), WaveUnits(yw,1), yw			// scale relative to cursor position in y direction
				Cursor/P/I $csr, $trace, s.dval, Findy													// move cursor to image position
			else
//				SetScale/P x, DimOffset(yw,0)-(modVal-s.dval), DimDelta(yw,0), WaveUnits(yw,0), yw			// scale relative to cursor position in x direction
				Cursor/P $csr, $trace, s.dval
			endif	
			print modVal, useY, s.dval, Findy															// move cursor to trace position
		
		break
		case "vRelShift":
			iniVal = str2num(StringFromList(useY,GetUserData(s.win, "vRelShift", "offset")))
			if (WaveExists(xw))
				modVal = s.dval - (xw[0] - iniVal)												// calculate the difference to the previous change
				xw += modVal
				break
			endif
			if (useY)
				SetScale/P y, iniVal+s.dval, DimDelta(yw,1), WaveUnits(yw,1), yw		
			else
				SetScale/P x, iniVal+s.dval, DimDelta(yw,0), WaveUnits(yw,0), yw
			endif
		break
		case "vArithmetic":
			ControlInfo/W=$(s.win) cImageOneCol;	Variable singleCol = V_Value && !V_disable
			DFREF saveDFR = GetDataFolderDFR()
			SetDataFolder GetWavesDataFolderDFR(yw)
			
			String MultiDim = ""
			if (WaveDims(yw)==2 && singleCol)													// working on 2D waves
				Variable col = qcsr($csr,gName)
				if (!strlen(ImageInfo(gName,trace,0)))											// waterfall plot
					String range = StringByKey("YRANGE", TraceInfo(gName,trace,0))				// find the displayed column from TraceInfo
					col = strsearch(range,"[",Inf,1)
					range = range[col+1,inf]
					col = str2num(RemoveEnding(range,"]"))
				endif
				if (numtype(col) == 0)
					MultiDim = "[]["+num2str(col)+"]"
				endif
			endif
			
			String Op = varStr[0]
			if ((CmpStr(Op, "+") == 0) || (CmpStr(Op, "-") == 0) || (CmpStr(Op, "*") == 0) || (CmpStr(Op, "/") == 0))
				String command = PossiblyQuoteName(NameOfWave(yw)) + MultiDim + Op + "=" + varStr[1,inf]			// construct a multiply command string
				Execute/Q/Z command
				if (V_flag)
					Print "There was an error with this command: " + GetErrMessage(V_Flag,2)
				endif
			else
				Print "You need to start your expression by a arithmetic operator +,-,* or /."
			endif
			SetDataFolder saveDFR
			break
	EndSwitch
	
	SetActiveSubwindow $gName																	// restore focus to main window
	return 0
End
//----------------------------------------------------------------------------------------------
Function QuickRescale_CheckExecute(s) : CheckBoxControl
	STRUCT WMCheckboxAction &s
	if(s.eventCode == 2)
		String gName = StringFromList(0, s.win, "#")
		String csr = GetUserData(s.win, "tCursor", "")											// extract from sub window
		if (CmpStr(csr,"none") != 0 && strlen(csr))
			String image = CsrWave($csr, gName)													// wave reference from cursor
			if (strlen(ImageInfo(gName,image,0)))												// update the cursor (recalculates the control values)
				Cursor/I/P $csr, $image, pcsr($csr, gName), qcsr($csr, gName)
			endif
		endif
	endif
	return 0
End
//